%%%
%%% support for "tps interactive"
%%%

declare F in F = 

functor
   
import
   System(printInfo) OS(getEnv)
   
   XService(cas:     CASService
            manager: ServiceManager)
   XApplication
   
define
   AppName     = 'tps-interactive'
   ServiceName = 'TPS-INTERACTIVE'
   App         = {New XApplication.manager init}

   Cmd         = {OS.getEnv 'TPSPROGRAM'}
   Args        = nil %['-r']

   if Cmd==false then
      raise undefinedVariable('TPSPROGRAM') end
   end

   VS2BS = VirtualString.toByteString
   
   %%fun {DropSpaces S} {List.dropWhile S Char.isSpace} end
   %%fun {Clear S} {Reverse {DropSpaces {Reverse {DropSpaces S}}}} end
   %%fun {NoNewlineOrBackslash C} C\=&\n andthen C\=&\\ end
   %%fun {IsAlphaOrSpace C} {Char.isAlpha C} orelse {Char.isSpace C} end
   %%fun {MkError S} error({VS2BS S}) end
   
   class TpsService from CASService
                       
      meth startCAS
         CASService, startCAS(cmd:Cmd args:Args
                              suffix: "\n"
                              prompt: ">" % "\n<DIGITS>"
                              subst:  nil
                              printInfo: System.printInfo)
      end
      /*
      meth preProcess(CommandVS $)
         CommandVS
      end
      */
      meth postProcess(S $)
         S1 = case {List.dropWhile {Reverse S} Char.isDigit} of &<|R then
                 {Reverse R}
              else S end
      in
         {VS2BS S1}
         /*
         case {Reverse S} of &^|_ then {MkError S}
         elsecase {List.dropWhile S IsAlphaOrSpace} of &:|& |_ then {MkError S}
         else
            {VS2BS {Clear S}}
         end
         */
      end

      meth startOmegaProblem(problemFile:  ProblemFileBS
                             matingSearch: MatingSearchVS <= "MS88")
         Tmp = {OS.tmpnam}
         {File.saveVS ProblemFileBS Tmp}
         {self eval("restoreproof \""#Tmp#"\"" ?Msg1VS)}
         Msg1S = {VS2S Msg1VS} 
         {System.show {List.isPrefix "Proof " Msg1S}} /*andthen*/
         {System.show {List.isPrefix {Reverse " restored.\n\n\n"} {Reverse Msg1S}}}
         {self eval("default-ms "#MatingSearchVS Msg2VS)}
         {System.show ({VS2S Msg2VS} == "\n\n\n")}
      in
         {self eval("diy" )
         
      end
      meth makeOmegaOutput(prtFile: ?PrtFileBS
                           prfFile: ?PrfFileBS
                           ...)
         
         
      end
   end
  
   ServMan = {New ServiceManager init(ServiceName TpsService
                                      appName: AppName
                                      appMan:  App)}
   {ServMan offerService}
   {App.exit 0}
end






