%%%
%%% Author:
%%%   Andreas Franke <afranke@ags.uni-sb.de>
%%%
%%% Copyright:
%%%   Andreas Franke, 2000
%%%
%%% Last change:
%%%   $Date $ by $Author $
%%%   $Revision $
%%%
%%% This file is part of MathWeb
%%%    http://www.mathweb.org/mathweb
%%%
%%% See the file "LICENSE" or
%%%    http://www.mathweb.org/mathweb/LICENSE.html
%%% for information on usage and redistribution
%%% of this file, and for a DISCLAIMER OF ALL
%%% WARRANTIES.
%%%


/*
Val Accept in
{XmlParser.parseVS Request ParserModule 'start_foopy'(?Val) ?Accept}
if Accept==false then
   {self beginResponse(...)}
   {self doctype}
   {self tag(html(head(title("400 Parse Error"))
                  body(h1("Parse Error")
                       "Sorry, your request could not be parsed.")))}
   {self endResponse}
   {Delay 1000}
   raise close end
end
%%{Browse OMDocName#Val}
{self }
{self...}

{self ok("Ok.")}
{Delay 1000}
*/
   
functor

import
   Foo(getCgiArgs: GetCgiArgs) at 'x-oz://system/Application.ozf'
   Connection(take)
   OS(getDir putEnv signal tmpnam unlink)
   Pickle(load save)
   Property(put)
   URL(make)

   XApplication at 'x-ozlib://mathweb/share/XApplication.ozf'
%   File         at 'x-ozlib://mathweb/share/File.ozf'
   Internet     at 'x-ozlib://mathweb/share/Internet.ozf'
   BrokerAccess(getBroker)
   at 'x-ozlib://mathweb/sys/BrokerAccess.ozf'

   Http(server:     BaseServer
	connection: BaseConnection)
   at 'x-ozlib://mathweb/httpd/Http.ozf'
   
%   XmlParser
%   at 'x-ozlib://mathweb/xmlparser/XmlParser.ozf'
%   PModule
%   at '/home/afranke/import/ilo/dtd/omdoc.parser.ozf'
%   SModule
%   at '/home/afranke/import/mathweb/xml/sem/omdoc.sem.ozf'

define
   VS2A = VirtualString.toAtom
   VS2S = VirtualString.toString
   
   {Property.put 'errors.width' 100}
   {Property.put 'errors.depth' 100}

   %%ParserModule = {XmlParser.link PModule SModule}
   %%{XmlParser.setDebug true}
  
   AppName = 'atpd'
   App     = {New XApplication.manager init}
   
   Spec = record(port(single char:&p type:int default:10000)
                 hostname(single char:&h type:string default:Internet.hostname)
                 brokerticket(single char:[&t &b] type:string
                              default:"http://www.ags.uni-sb.de/~ilo/broker@leibniz")
                 portticketdir(single type:string
                               default:"http://www.mathweb.org/~mathweb/")
                 name(single char:&n type:atom default:'atp')
                 default(single type:string default:false)
                )
   Args
   try
      Args = {App.getCmdArgs Spec}
   catch error(ap(usage S)...) then
      {App.showError AppName#": "#S}
      {App.exit 1}
   end

   if Args.hostname\=Internet.hostname andthen
      {Internet.sameHosts Args.hostname Internet.hostname}==false
   then
      {App.showError "Sorry, "#Args.hostname#" and "#Internet.hostname#
       " seem to be different hosts :-("}
      {App.exit 1}
   end
   HOSTNAME = Args.hostname 
   PORT     = Args.port
   PREFIX   = "http://"#HOSTNAME#":"#PORT
   
   local          
      class Counter
         attr
            counter:0
            
         meth init(N0<=0)
            counter <- N0
         end         
         meth next(?N)
            N = @counter + 1
            counter <- N
         end
      end
      class ServRegistry
         prop
            locking
         feat
            broker
            counter
            dict
           
         meth init(broker:Broker)
            self.broker  = Broker
            self.counter = {New Counter init}
            self.dict    = {NewDictionary}
         end
         meth new(ServiceName ?ID)
            lock
               case {Broker request(ServiceName $)}
               of false then
                  raise unknownService(ServiceName) end
               [] Obj then
                  {Obj enter}
                  ID = {self.counter next($)}
                  {Dictionary.put self.dict ID Obj}
               end
            end
         end
         meth send(ID Msg)
            case {Dictionary.condGet self.dict ID false}
            of false then
               raise unknownID(ID) end
            [] Obj then
               {Obj Msg}
            end
         end
         meth release(ID)
            lock
               case {Dictionary.condGet self.dict ID false}
               of false then
                  raise unknownID(ID) end
               [] Obj then
                  try {Obj leave}
                  catch _ then skip end
                  {Dictionary.remove self.dict ID}
               end
            end
         end
         meth releaseAll
            lock
               {ForAll {Dictionary.items self.dict}
                proc {$ Obj}
                   try {Obj leave}
                   catch _ then skip end
                end}
               {Dictionary.removeAll self.dict}
            end
         end
      end
   in
      Broker = {BrokerAccess.getBroker App Args}.send
      ServReg = {New ServRegistry init(broker: Broker)}
   end
   
   local
      QueryLock = {NewLock}
   in
      fun {ParseQuery Query Spec}
	 QueryString = if Query==unit then "" else Query end
      in
	 lock QueryLock then
	    {OS.putEnv "REQUEST_METHOD" "GET"}
	    {OS.putEnv "QUERY_STRING" QueryString}
	    {GetCgiArgs Spec}
         end
      end
      
      fun {QueryToRecord Query}
	 {List.toRecord unit
	  {Map {ParseQuery Query plain}
	   fun {$ Var#Val}
	      {StringToAtom Var}#{Filter Val fun {$ C}
						C \= &\r
					     end}
	   end}}     
      end
      /*
      fun {ParseFormContent Content}
         {ParseQuery Content plain}
      end
      */
   end
   
   fun {EscapeHtml S}
      case S of nil then nil
      [] C|R then
         case C
         of &<  then &&|&l|&t|&;|{EscapeHtml R}
         [] &>  then &&|&g|&t|&;|{EscapeHtml R}
         [] &&  then &&|&a|&m|&p|&;|{EscapeHtml R}
         [] &\\ then &\\|&\\|{EscapeHtml R}
         else C|{EscapeHtml R}
         end
      end
   end
   
   class ConnectionManager
      from
	 BaseConnection
	 
      meth beginResponseBase
	 BaseConnection, beginResponse
	 {self tag(base(href:PREFIX)#"\n")}
      end

      meth 'GET'(X...) = GET
         U = {URL.make X}
         P = U.path
      in
	 case P of [nil] then
	    BaseConnection, 'GET'("/index.html")
         [] ["atp.cgi"] then
	    {self ATPGet(U)}
	 else
            BaseConnection, GET
         end
      end

      meth 'POST'(X Content...) = POST
         U = {URL.make X}
         P = U.path
      in
         case P of ["atp.cgi"] then
            {self ATPPost(U Content)}
         else
            BaseConnection, POST
         end
      end
      /*
      meth DumpValues(ContentR)
         {Record.forAllInd ContentR
          proc {$ Var Val}
             {self write(vs:Var#" = "#Val#"\n")}
          end}
      end
      */
      meth ATPGet(U)
         Params = {QueryToRecord U.query}
	 ATPName = {CondSelect Params atpname "SPASS"}
	 Syntax = {CondSelect Params syntax dfg}
	 Expr = Params.input
	 Result = {self CallATP(service:ATPName expr:Expr syntax: Syntax $)}
      in
	 case Result
	 of error(Message ...) then 
	    BaseConnection, ok("Sorry, the chosen ATP produced an error"#Message type:'text/plain')
	 else
	    BaseConnection, ok(Result type:'text/plain')
	 end
	 {Delay 1000}
      end

      meth ATPPost(U Content)
	 Params = {QueryToRecord U.query}
	 ATPName Expr Syntax
         case {CondSelect Params mode "browser"} of "browser" then
	    R = {QueryToRecord Content}
            {App.show R}
         in
	    ATPName = R.atpname
	    Syntax = R.syntax
            Expr    = R.input
	 else
	    ATPName = {CondSelect Params service "SPASS"}
	    Syntax = {CondSelect Params syntax dfg}
	    Expr    = Content
	 end
	 Result = {self CallATP(service:ATPName expr:Expr syntax: Syntax $)}
      in
%	 {Browse Result}
	 
	 case Result
	 of error(Message ...) then 
	    BaseConnection, ok("Sorry, the chosen ATP produced an error"#Message type:'text/plain')
	 [] s(bool: Failed string: Message ...) then
	    if Failed then
	       BaseConnection, beginResponse
	       BaseConnection, write(vs: "The proof attempt failed with message:\n")
	       BaseConnection, write(vs: Message)
	       BaseConnection, endResponse
	    else
	       BaseConnection, beginResponse
	       BaseConnection, write(vs: "Proof found!!!\n")
	       BaseConnection, write(vs: "<pre>"#Message#"</pre>")
	       BaseConnection, endResponse
	    end
	 else
	    BaseConnection, ok(Result type:'text/plain')
	 end
         {Delay 1000}
      end


      meth CallATP(service: ATPName
		   expr: Expr
		   syntax: Syntax
                   ?Result)
	 ServiceName = {VS2A {Map {VS2S ATPName} Char.toUpper}} 
	 {App.printInfo "Creating new service..."}
	 ID = {ServReg new(ServiceName $)}
	 {App.showInfo " ID = "#ID}
      in
%	 {Browse syntax(Syntax)}
	 try
	    {App.printInfo "Calling submitProblem(`"#Expr#"') ..."}
%	    {ServReg send(ID submitProblem(Expr))}
%	    Result = {ServReg send(ID analyzeResult($))}
	    Result = {ServReg send(ID prove(Expr syntax: {VS2A Syntax} $))}
	    {Wait Result}
	    {App.show Result}
	 finally
	    {ServReg release(ID)}
         end
      end
   end
   
   Server = {New BaseServer init(port:        PORT
                                 acceptClass: ConnectionManager)}
   
   {App.showInfo HOSTNAME#":"#PORT}
   
   ExitSignal
   local
      proc {Term SIGNAL}
         {App.showError "*** "#SIGNAL#" ***"}
         ExitSignal=unit
      end
   in
      {OS.signal 'SIGHUP' Term}
      {OS.signal 'SIGINT' Term}
      {OS.signal 'SIGTERM' Term}
   end
   
%    try
%       ServiceID
%       PortUrl = Args.portticketdir#"portticket.ozc"
%       PortTicket = {Pickle.load PortUrl}
%       PortPoint = {Connection.take PortTicket} 
%       {Wait PortPoint}
%       {App.printInfo "PortPoint = "} {App.show PortPoint}
%       {PortPoint offer(Args.name Available ?ServiceID host:HOSTNAME)}
%    in
%       try
%          {Wait ExitSignal}
%       finally
%          try
%             {PortPoint retire(ServiceID)}
%          catch Err then
%             {App.showError 'Error in "{PortPoint retire(...)}":'}
%             {App printExc(Err)}
%          end
%       end
   try
      {Wait ExitSignal}
   finally
      {Server close}
      {App.exit 0}
   end
end


         
         
         
         
         
