%%%
%%% EQP agent
%%%

functor
   
import
   OS(getEnv) Error

   XService(manager: ServiceManager)
   at 'x-ozlib://mathweb/sys/XService.ozf'
   ShellProverClass('class': ShellProver)
   at 'x-ozlib://mathweb/sys/ShellProver.ozf'
   
   XApplication
   at 'x-ozlib://mathweb/share/XApplication.ozf'

define
   AppName     = 'eqp'
   ServiceName = 'EQP'
   App         = {New XApplication.manager init}
   
   ProofLine  = "---------------- PROOF ----------------"
   ProofBegin = "After processing input:"
   ProofEnd   = "------------ end of proof -------------"

   EQP = {OS.getEnv "EQPHOME"}
   
   fun {ExceptionToVS Err}
      {Error.messageToVirtualString {Error.exceptionToMessage Err}}
   end

   fun {Find F Line}
      case {F getS($)}
      of false then false
      [] !Line then true
      else {Find F Line}
      end
   end

   fun {Take F End}
      case {F getS($)}
      of false then nil
      [] !End  then End#'\n'
      [] Line  then Line#'\n'#{Take F End}
      end
   end
   
   class EqpService from ShellProver
      feat
         name: eqp
         
      meth submitProblem(ProblemBS...)
         EqpIn  = "eqp.in"  %{OS.tmpnam}
         EqpOut = "eqp.out" %{OS.tmpnam}
         {self saveVS(ProblemBS EqpIn)}
         CallEqp = EQP#" <"#EqpIn#" >"#EqpOut#" 2>&1"
      in
         {self start(CallEqp)}
      end

      meth analyzeResult($)
         File1
      in
         try
            State Result ProofOk Output
         in
            File1 = {self openRead("eqp.out" $)}
            ProofOk = {Find File1 ProofLine}
            {File1 close}
            case ProofOk
            of true then
               File2 = {self openRead("eqp.out" $)}
            in   
               State = if {Find File2 ProofBegin}
                       then proof
                       else undetermined
                       end
               Output = if State == proof then
                           ProofBegin#'\n'#{Take File2 ProofEnd}
                        else
                           {self readAll(File2 $)}
                        end
               Result = atp_result(state: State
                                   name: self.name
                                   host: self.host
                                   output: Output
                                  )
               {File2 close}
               Result
            else
               File2 = {self openRead("eqp.out" $)}
            in
               Output = {self readAll(File2 $)}               
               {File2 close}
               Result = atp_result(state: undetermined
                                   name: self.name
                                   host: self.host
                                   output: Output
                                  )
               Result
            end
         catch E then
            Output
         in
            {App.showInfo {ExceptionToVS E}}            
            try
               Output = {self readAll(File1 $)}
               {File1 close}
            catch _ then skip end
            atp_result(state: error
                       name:  self.name
                       host:  self.host
                       output: if {IsDet Output} then Output else nil end
                      )
         end
      end
   end
   
   ServMan = {New ServiceManager init(ServiceName EqpService
                                      appName: AppName
                                      appMan:  App)}
   {ServMan offerService}
   {App.exit 0}
end

%       meth submitProblem(ProblemBS...)
%          EqpIn  = "eqp.in"  %{OS.tmpnam}
%          EqpOut = "eqp.out" %{OS.tmpnam}
%          {self saveVS(ProblemBS EqpIn)}
%          CallEqp = EQP#" <"#EqpIn#" >"#EqpOut
%       in
%          {self start(CallEqp)}
%       end

%       meth analyzeResult($)
%          Proof ProofOk Failed
%          local
%             F = {self openRead("eqp.out" $)} in
%             ProofOk = {Find F ProofLine}
%             {F close}
%             case ProofOk
%             of true then
%                F = {self openRead("eqp.out" $)} in   
%                if {Find F ProofBegin}
%                then Failed=false Proof=ProofBegin#'\n'#{Take F ProofEnd}
%                else Failed=error Proof="syntax error\n"
%                end
%                {F close}
%             [] false   then Proof = "-------------------------------\n"
%             [] error   then Proof = "syntax error\n"
% 	    [] unknown then Proof = "unknown result\n"
%             end
%             if {IsDet Failed}==false then Failed=true end
%          end
%       in
%          s(string:{ByteString.make Proof} bool:Failed? host:self.host)
%       end
