 %%%
%%% SPASS agent
%%%

functor
   
import
   OS(getEnv /*tmpnam*/)

   XService(manager: ServiceManager)
   at 'x-ozlib://mathweb/sys/XService.ozf'
   ShellProverClass('class': ShellProver)
   at 'x-ozlib://mathweb/sys/ShellProver.ozf'

   XApplication
   at 'x-ozlib://mathweb/share/XApplication.ozf'
   
define
   AppName     = 'spass'
   ServiceName = 'SPASS'
   App         = {New XApplication.manager init}

   ProofBegin = "SPASS beiseite: Proof found."  
   Completion = "SPASS beiseite: Completion found."

   SPASS = {OS.getEnv "SPASSHOME"}
   
   class SpassService from ShellProver
      feat
         name: spass
         
      meth submitProblem(ProblemBS syntax: Syntax <= unit)
	 SpassIn  = "spass.in"  %{OS.tmpnam}
	 SpassOut = "spass.out" %{OS.tmpnam}
	 {self saveVS(ProblemBS SpassIn)}
	 CallSpass = SPASS#" "#SpassIn#" >"#SpassOut#" 2>&1"
      in
	 {self start(CallSpass)}
         %tmpfiles <- [SpassIn]
         %outfile  <- SpassOut
      end

      meth analyzeResult($)
         F  
         fun {ProofFound}
            case {F getS($)}
            of false       then undetermined
            [] !Completion then satisfiable
            [] !ProofBegin then proof
            else {ProofFound}
            end
         end
         fun {Take}
            case {F getS($)}
            of false then nil
            [] Line  then Line#'\n'#{Take}
            end
         end
      in
	 try
	    State Result
         in
            F = {self openRead("spass.out" /*@outfile*/ $)}
	    State = {ProofFound}
            
            Result = atp_result(state: State
                                name:  self.name
                                host:  self.host
                                output: (if State == proof then ProofBegin#"\n" else nil end)#{Take}
                               )
            {F close}
            Result
	 catch _ then Output in
	    try
               Output = {Take}
               {F close}
            catch _ then skip end
	    atp_result(state: error
                       name:  self.name
                       host:  self.host
                       output: if {IsDet Output} then Output else nil end
                      )
	 end
      end
   end
   
   ServMan = {New ServiceManager init(ServiceName SpassService
                                      appName: AppName
                                      appMan:  App)}
   {ServMan offerService}
   {App.exit 0}
end

% 	    fun {ProofFound}
% 	       case {F getS($)}
% 	       of false       then unknown
% 	       [] !Completion then false
% 	       [] !ProofBegin then true
% 	       else {ProofFound}
%                end
% 	    end
% 	    ProofOk = {ProofFound}
	    
% 	    fun {Take}
% 	       case {F getS($)}
% 	       of false then nil
% 	       [] Line  then Line#'\n'#{Take}
% 	       end
% 	    end
% 	 in
% 	    Failed? = {Member ProofOk [false error unknown]}
% 	    case ProofOk
% 	    of true    then Proof = ProofBegin#'\n'#{Take}
% 	    [] false   then Proof = "-------------------------------\n"
% 	    [] error   then Proof = "syntax error\n"
% 	    [] unknown then Proof = "unknown result\n"
% 	    end
