%%
%%  a test program for Alexander
%%

functor
   
import
   System
   Browser(browse: Browse)

   XApplication
   at 'x-ozlib://mathweb/share/XApplication.ozf'
   BrokerAccess(getBroker)
   at 'x-ozlib://mathweb/sys/BrokerAccess.ozf'
   
define
   App     = {New XApplication.manager init}
   AppName = "testspass"
   %% The command line arguments
%   DefaultTicket = "http://www.mathweb.org/~jzimmer/broker@goedel"
   DefaultTicket = "http://www.mathweb.org/~jzimmer/broker@gentzen"
   Spec = record(brokerticket(single type:string default: DefaultTicket))

Args
   try
      Args = {App.getCmdArgs Spec}
   catch error(ap(usage S)...) then
      {App.showError AppName#': '#S}
      {App.exit 1}
   end
   %% end of args
   
   Broker = {BrokerAccess.getBroker App Args}.send
   
   Atp = {Broker request("ATP" $)}
   
%%-----------------------
%% DFG syntax
%%-----------------------
   Problem = "begin_problem(Pelletier54).
list_of_descriptions.
name({*Pelletier\'s Problem No. 54*}).
author({*Christoph Weidenbach*}).
status(unsatisfiable).
description({*Problem taken in revised form from
              the \"Pelletier Collection\",
              Journal of Automated Reasoning, Vol. 2, No. 2, pages 191-216*}).
end_of_list.

list_of_symbols.
  predicates[(F,2)].
end_of_list.

list_of_formulae(axioms).
  formula(forall([U],exists([V],forall([W],equiv(F(W,V),equal(W,U)))))).
end_of_list.

list_of_formulae(conjectures).
  formula(not(exists([U],forall([V],equiv(F(V,U),forall([W],implies(F(V,W),exists([X],and(F(X,W),not(exists([Y],and(F(Y,W),F(Y,X))))))))))))).

end_of_list.

end_problem."

   OtterProblem = "%%%% MODE FLAGS %%%%

set(auto).
set(build_proof_object).

%%%% USER INPUT %%%%



%%%% NEEDED FLAGS FOR PARSING %%%%

set(detailed_history).
set(order_history).
set(prolog_style_variables).
set(factor).
set(demod_history).
clear(sort_literals).
clear(propositional).
clear(delete_identical_nested_skolem).
clear(symbol_elim).
clear(lex_order_vars).


%%%% THE NAME CONVERSIONS %%%%
%%%%    DC-2857  -->  OB_DC2857_33
%%%%    DC-2856  -->  OB_DC2856_32
%%%%    DC-2855  -->  OB_DC2855_31
%%%%    DC-2851  -->  OB_DC2851_30
%%%%    DC-2850  -->  OB_DC2850_29
%%%%    DC-2849  -->  OB_DC2849_28
%%%%    DC-2845  -->  OB_DC2845_27
%%%%    *INV  -->  ob_inv_26
%%%%    DC-2844  -->  OB_DC2844_25
%%%%    DC-2842  -->  OB_DC2842_24
%%%%    DC-2841  -->  OB_DC2841_23
%%%%    DC-2839  -->  OB_DC2839_22
%%%%    DC-2838  -->  OB_DC2838_21
%%%%    DC-2837  -->  OB_DC2837_20
%%%%    DC-2833  -->  OB_DC2833_19
%%%%    DC-2832  -->  OB_DC2832_18
%%%%    DC-2829  -->  OB_DC2829_17
%%%%    DC-2828  -->  OB_DC2828_16
%%%%    DC-2826  -->  OB_DC2826_15
%%%%    ZERO  -->  ob_zero_14
%%%%    DC-2825  -->  OB_DC2825_13
%%%%    DC-2823  -->  OB_DC2823_12
%%%%    DC-2822  -->  OB_DC2822_11
%%%%    DC-2821  -->  OB_DC2821_10
%%%%    DC-2817  -->  OB_DC2817_9
%%%%    DC-2816  -->  OB_DC2816_8
%%%%    +  -->  ob__7
%%%%    sk_0_A_854943  -->  ob_sk_0_a_854943_6
%%%%    E  -->  ob_e_5
%%%%    +INV  -->  ob_inv_4
%%%%    *  -->  ob__3
%%%%    =  -->  ob__2
%%%%    X-1  -->  OB_X1_1
%%%%    =  -->  =

%%%% THE CLAUSE LISTS %%%%

list(usable).
-ADDITIONALNONPROPPRED_1(ADDITIONALNONPROPCONS_1).

OB_X1_1=OB_X1_1.

ob__3(ob_inv_4(ob_e_5),ob_sk_0_a_854943_6)!=ob_inv_4(ob_sk_0_a_854943_6).

ob__7(OB_DC2816_8,OB_DC2817_9)=ob__7(OB_DC2817_9,OB_DC2816_8).

ob__7(ob__7(OB_DC2821_10,OB_DC2822_11),OB_DC2823_12)=ob__7(OB_DC2821_10,ob__7(OB_DC2822_11,OB_DC2823_12)).

ob__7(OB_DC2825_13,ob_zero_14)=OB_DC2825_13.

ob__7(ob_zero_14,OB_DC2826_15)=OB_DC2826_15.

ob__7(OB_DC2828_16,ob_inv_4(OB_DC2828_16))=ob_zero_14.

ob__7(ob_inv_4(OB_DC2829_17),OB_DC2829_17)=ob_zero_14.

ob__3(OB_DC2832_18,OB_DC2833_19)=ob__3(OB_DC2833_19,OB_DC2832_18).

ob__3(ob__3(OB_DC2837_20,OB_DC2838_21),OB_DC2839_22)=ob__3(OB_DC2837_20,ob__3(OB_DC2838_21,OB_DC2839_22)).

ob__3(OB_DC2841_23,ob_e_5)=OB_DC2841_23.

ob__3(ob_e_5,OB_DC2842_24)=OB_DC2842_24.

ob_e_5!=ob_zero_14.

OB_DC2844_25=ob_zero_14 | ob__3(OB_DC2844_25,ob_inv_26(OB_DC2844_25))=ob_e_5.

OB_DC2845_27=ob_zero_14 | ob__3(ob_inv_26(OB_DC2845_27),OB_DC2845_27)=ob_e_5.

ob__3(OB_DC2849_28,ob__7(OB_DC2850_29,OB_DC2851_30))=ob__7(ob__3(OB_DC2849_28,OB_DC2850_29),ob__3(OB_DC2849_28,OB_DC2851_30)).

ob__3(ob__7(OB_DC2855_31,OB_DC2856_32),OB_DC2857_33)=ob__7(ob__3(OB_DC2855_31,OB_DC2857_33),ob__3(OB_DC2856_32,OB_DC2857_33)).

end_of_list."

%%-----------------------
%% PROTEIN syntax
%%-----------------------
MSC006_1 = "          
% BEGIN_AXIOMS
% NAME: transitive(p)
p(X, Z) :- p(X, Y), p(Y, Z).

% NAME: transitive(q)
q(X, Z) :- q(X, Y), q(Y, Z).

% NAME: symmetric(q)
q(Y, X) :- q(X, Y).

% NAME: all_related(p,q)
p(X, Y); q(X, Y).

% NAME: not_total(p)
- p(a, b).

% NAME: goal 
?- q(c, d).

% END_AXIOMS"

%    {Browse Result}
   %% create maple object
%    ATP = {Call Url "Broker.getService" ["ATP"]}
   
%    %% compute 1+1
%    Result = {Call ATP "proveProblem" [unit(id: 1000234
% 					   problem: unit(protein: {VS2BS MSC006_1})
% 					   provers: {VS2BS protein}#{VS2BS bliksem}
% 					   mode:   {VS2BS all}
% 					   timeout: 30)]}

   VS2BS = VirtualString.toByteString

   Result
%    Return = proc{$ VS}
%                if {IsVirtualString VS} then
%                   {System.showInfo VS}
%                else
%                   {System.show VS}
%                end
%             end


   {Atp enter(mode: oz)}
   {Atp proveProblem(problem(id: 123134 
                             problem: unit(bliksem: Problem#dfg
                                           protein: MSC006_1
                                           spass: Problem
                                           otter: OtterProblem)
                             provers: [protein bliksem spass otter]
                             mode:    inc
                             timeOut: 30)
                     ?Result)}
   {Wait Result}
   {Browse Result}
%% Result is a record
%%     s(string: Proof      % the proof!
%%       bool:   Failed?    % boolean indicating if the prover is failed 
%%       host:   self.host) % name of the host the prover runs on

   {Atp leave}

%   {App.exit 0}
end


