%%
%%  a test program for Alexander
%%

functor
   
import
   XApplication
   at 'x-ozlib://mathweb/share/XApplication.ozf'
   
   Browser(browse: Browse)
   
   BrokerAccess(getBroker)
   at 'x-ozlib://mathweb/sys/BrokerAccess.ozf'
   
define
   App     = {New XApplication.manager init}
   AppName = "testfdpll"
   %% The command line arguments
   DefaultTicket = "http://www.mathweb.org/~jzimmer/broker@goedel"
   Spec = record(brokerticket(single type:string default: DefaultTicket))

Args
   try
      Args = {App.getCmdArgs Spec}
   catch error(ap(usage S)...) then
      {App.showError AppName#': '#S}
      {App.exit 1}
   end
   %% end of args
   
   Broker = {BrokerAccess.getBroker App Args}.send
   
   Fdpll = {Broker request("FDPLL" $)}
   
   Problem = "begin_problem(Natural_Language_Discourse).

list_of_descriptions.
name({* DORIS *}).
author({* www.coli.uni-sb.de/~bos/doris/ *}).
status(unknown).
description({* Reading: r(1,cons,1) Discourse: 
a man walks *}).
end_of_list.

list_of_symbols.
predicates[(walk,2),(present,1),(event,1),(unisex,1),(eventuality,1),(male,1),(man,1),(human_person,1),(organism,1),(single,1),(entity,1)].
end_of_list.

list_of_formulae(axioms).
formula(forall([A],implies(entity(A),single(A)))).
formula(forall([B],implies(organism(B),entity(B)))).
formula(forall([C],implies(human_person(C),organism(C)))).
formula(forall([D],implies(man(D),human_person(D)))).
formula(forall([E],implies(man(E),male(E)))).
formula(forall([F],implies(eventuality(F),single(F)))).
formula(forall([G],implies(eventuality(G),unisex(G)))).
formula(forall([H],implies(event(H),eventuality(H)))).
formula(forall([I],implies(eventuality(I),not(entity(I))))).
formula(forall([J],implies(unisex(J),not(male(J))))).
end_of_list.

list_of_formulae(conjectures).
formula(not(exists([A],exists([B],and(man(A),and(event(B),and(present(B),walk(B,A)))))))).
end_of_list.

end_problem."

%       meth prove(ProblemBS ?Result
% 		 syntax: Syntax <= unit
% 		 times:  ?Times <= _
% 		)
   VS2BS = VirtualString.toByteString

   Result 
   {Fdpll enter}
   {Fdpll prove({VS2BS Problem} ?Result
		syntax: dfg
                replyWith: result(state: unit
                                  name: unit
                                  host: unit
                                  times: unit
                                  output: unit)
               )}
   {Wait Result}
   {Browse Result}
%% Result is a record
%%     s(string: Proof      % the proof!
%%       bool:   Failed?    % boolean indicating if the prover is failed 
%%       host:   self.host) % name of the host the prover runs on

   {Fdpll leave}

%   {App.exit 0}
end


