%%
%%  a test program for otter
%%

functor
   
import
   XApplication
   at 'x-ozlib://mathweb/share/XApplication.ozf'
   
   Browser(browse: Browse)
   
   BrokerAccess(getBroker)
   at 'x-ozlib://mathweb/sys/BrokerAccess.ozf'
   
define
   App     = {New XApplication.manager init}
   AppName = "testotter"
   %% The command line arguments
   DefaultTicket = "http://www.mathweb.org/~jzimmer/broker@goedel"
   Spec = record(brokerticket(single type:string default: DefaultTicket))

Args
   try
      Args = {App.getCmdArgs Spec}
   catch error(ap(usage S)...) then
      {App.showError AppName#': '#S}
      {App.exit 1}
   end
   %% end of args
   
   Broker = {BrokerAccess.getBroker App Args}.send
   
   Otter = {Broker request("OTTER" $)}
   
   Problem = "%%%% MODE FLAGS %%%%

set(auto).
set(build_proof_object).

%%%% USER INPUT %%%%



%%%% NEEDED FLAGS FOR PARSING %%%%

set(detailed_history).
set(order_history).
set(prolog_style_variables).
set(factor).
set(demod_history).
clear(sort_literals).
clear(propositional).
clear(delete_identical_nested_skolem).
clear(symbol_elim).
clear(lex_order_vars).


%%%% THE NAME CONVERSIONS %%%%
%%%%    DC-2857  -->  OB_DC2857_33
%%%%    DC-2856  -->  OB_DC2856_32
%%%%    DC-2855  -->  OB_DC2855_31
%%%%    DC-2851  -->  OB_DC2851_30
%%%%    DC-2850  -->  OB_DC2850_29
%%%%    DC-2849  -->  OB_DC2849_28
%%%%    DC-2845  -->  OB_DC2845_27
%%%%    *INV  -->  ob_inv_26
%%%%    DC-2844  -->  OB_DC2844_25
%%%%    DC-2842  -->  OB_DC2842_24
%%%%    DC-2841  -->  OB_DC2841_23
%%%%    DC-2839  -->  OB_DC2839_22
%%%%    DC-2838  -->  OB_DC2838_21
%%%%    DC-2837  -->  OB_DC2837_20
%%%%    DC-2833  -->  OB_DC2833_19
%%%%    DC-2832  -->  OB_DC2832_18
%%%%    DC-2829  -->  OB_DC2829_17
%%%%    DC-2828  -->  OB_DC2828_16
%%%%    DC-2826  -->  OB_DC2826_15
%%%%    ZERO  -->  ob_zero_14
%%%%    DC-2825  -->  OB_DC2825_13
%%%%    DC-2823  -->  OB_DC2823_12
%%%%    DC-2822  -->  OB_DC2822_11
%%%%    DC-2821  -->  OB_DC2821_10
%%%%    DC-2817  -->  OB_DC2817_9
%%%%    DC-2816  -->  OB_DC2816_8
%%%%    +  -->  ob__7
%%%%    sk_0_A_854943  -->  ob_sk_0_a_854943_6
%%%%    E  -->  ob_e_5
%%%%    +INV  -->  ob_inv_4
%%%%    *  -->  ob__3
%%%%    =  -->  ob__2
%%%%    X-1  -->  OB_X1_1
%%%%    =  -->  =

%%%% THE CLAUSE LISTS %%%%

list(usable).
-ADDITIONALNONPROPPRED_1(ADDITIONALNONPROPCONS_1).

OB_X1_1=OB_X1_1.

ob__3(ob_inv_4(ob_e_5),ob_sk_0_a_854943_6)!=ob_inv_4(ob_sk_0_a_854943_6).

ob__7(OB_DC2816_8,OB_DC2817_9)=ob__7(OB_DC2817_9,OB_DC2816_8).

ob__7(ob__7(OB_DC2821_10,OB_DC2822_11),OB_DC2823_12)=ob__7(OB_DC2821_10,ob__7(OB_DC2822_11,OB_DC2823_12)).

ob__7(OB_DC2825_13,ob_zero_14)=OB_DC2825_13.

ob__7(ob_zero_14,OB_DC2826_15)=OB_DC2826_15.

ob__7(OB_DC2828_16,ob_inv_4(OB_DC2828_16))=ob_zero_14.

ob__7(ob_inv_4(OB_DC2829_17),OB_DC2829_17)=ob_zero_14.

ob__3(OB_DC2832_18,OB_DC2833_19)=ob__3(OB_DC2833_19,OB_DC2832_18).

ob__3(ob__3(OB_DC2837_20,OB_DC2838_21),OB_DC2839_22)=ob__3(OB_DC2837_20,ob__3(OB_DC2838_21,OB_DC2839_22)).

ob__3(OB_DC2841_23,ob_e_5)=OB_DC2841_23.

ob__3(ob_e_5,OB_DC2842_24)=OB_DC2842_24.

ob_e_5!=ob_zero_14.

OB_DC2844_25=ob_zero_14 | ob__3(OB_DC2844_25,ob_inv_26(OB_DC2844_25))=ob_e_5.

OB_DC2845_27=ob_zero_14 | ob__3(ob_inv_26(OB_DC2845_27),OB_DC2845_27)=ob_e_5.

ob__3(OB_DC2849_28,ob__7(OB_DC2850_29,OB_DC2851_30))=ob__7(ob__3(OB_DC2849_28,OB_DC2850_29),ob__3(OB_DC2849_28,OB_DC2851_30)).

ob__3(ob__7(OB_DC2855_31,OB_DC2856_32),OB_DC2857_33)=ob__7(ob__3(OB_DC2855_31,OB_DC2857_33),ob__3(OB_DC2856_32,OB_DC2857_33)).

end_of_list."

%       meth prove(ProblemBS ?Result
% 		 syntax: Syntax <= unit
% 		 times:  ?Times <= _
% 		)
   VS2BS = VirtualString.toByteString

   Result 
   {Otter enter}
   {Otter prove({VS2BS Problem} ?Result
                replyWith: result(state: unit
                                  name: unit
                                  host: unit
                                  times: unit
                                  output: unit)
               )}
   {Wait Result}
   {Browse Result}
%% Result is a record
%%     s(string: Proof      % the proof!
%%       bool:   Failed?    % boolean indicating if the prover is failed 
%%       host:   self.host) % name of the host the prover runs on

   {Otter leave}

%   {App.exit 0}
end


