%%%
%%% Author:
%%%   Andreas Franke <afranke@ags.uni-sb.de>
%%%
%%% Copyright:
%%%   Andreas Franke, 2000
%%%
%%% Last change:
%%%   $Date $ by $Author $
%%%   $Revision $
%%%
%%% This file is part of MathWeb
%%%    http://www.mathweb.org/mathweb
%%%
%%% See the file "LICENSE" or
%%%    http://www.mathweb.org/mathweb/LICENSE.html
%%% for information on usage and redistribution
%%% of this file, and for a DISCLAIMER OF ALL
%%% WARRANTIES.
%%%

functor

import
%   Foo(getCgiArgs:GetCgiArgs) at 'x-oz://system/Application.ozf'
   Connection(take)
   OS(getDir putEnv signal tmpnam unlink)
   Pickle(load save)
   Property(put)
   URL(make)

%   System
   Browser(browse: Browse)

   XApplication at 'x-ozlib://mathweb/share/XApplication.ozf'
   XURL         at 'x-ozlib://mathweb/share/XURL.ozf'
   File         at 'x-ozlib://mathweb/share/File.ozf'
   Internet     at 'x-ozlib://mathweb/share/Internet.ozf'

define
   VS2A = VirtualString.toAtom
%   VS2S = VirtualString.toString
   
   {Property.put 'errors.width' 100}
   {Property.put 'errors.depth' 100}

  
   AppName = 'pvs test'
   App     = {New XApplication.manager init}
   
   Spec = record(port(single char:&p type:int default:20000)
		 hostname(single char:&h type:string default:Internet.hostname)
		 brokerticket(single char:[&t &b] type:string
			      default:"http://www.ags.uni-sb.de/~jzimmer/broker@gentzen")
		 portticketdir(single type:string
			       default:"http://www.mathweb.org/~mathweb/")
		 name(single char:&n type:atom default:'cas')
                 default(single type:string default:false)
                )
   Args
   try
      Args = {App.getCmdArgs Spec}
   catch error(ap(usage S)...) then
      {App.showError AppName#": "#S}
      {App.exit 1}
   end

%    if Args.hostname\=Internet.hostname andthen
%       {Internet.sameHosts Args.hostname Internet.hostname}==false
%    then
%       {App.showError "Sorry, "#Args.hostname#" and "#Internet.hostname#
%        " seem to be different hosts :("}
%       {App.exit 1}
%    end

%   HOSTNAME = Args.hostname 
%   PORT     = Args.port
%   PREFIX   = "http://"#HOSTNAME#":"#PORT

   BrokerTicket BrokerURL
   
   case {App.getEnv 'BROKER_TICKET'}
   of false then
      if {HasFeature Args brokerticket} then
	 BrokerURL = Args.brokerticket
	 {App.printInfo "Loading broker-ticket from `"#BrokerURL#"'..."}
	 BrokerTicket = if {File.type BrokerURL}==dir
			then {Pickle.load BrokerURL#"/broker-ticket.ozc"}
			else {VS2A {XURL.loadVS BrokerURL}}
			end
	 {App.showInfo " done."}
      else
	 {App.show no_broker_ticket_set}
	 BrokerURL = "http://www.ags.uni-sb.de/~omegadev/broker-ticket.ozc"
	 {App.printInfo "Loading broker-ticket from `"#BrokerURL#"'..."}
	 BrokerTicket = {Pickle.load BrokerURL}
	 {App.showInfo " done."}
      end
   [] BROKER_TICKET then
      {App.show broker_ticket(BROKER_TICKET)}
      BrokerURL    = false
      BrokerTicket = {VirtualString.toAtom BROKER_TICKET}
   end
   {App.printInfo "Connecting to broker at "#Args.brokerticket#"..."}
   {App.showInfo " done."}
   Broker = {Connection.take BrokerTicket}
   
   {App.showInfo " done"}
   
   PVSService = {Broker request('PVS' $ locally: true)}
   try
      if PVSService \= false then
	 {PVSService enter}
%	 PVSResult = {PVSService prove("0=1" $)}
	 PVSResult = nil
      in
	 {Delay 100000}
	 {PVSService leave}
	 {Wait PVSResult}
	 {App.showInfo "result: "#PVSResult}
      end
% T
% OMEGA(8): (serv~apply "PVS" "provetf(\"0=1\")")
% "False"
% OMEGA(9): (serv~apply "PVS" "prove(\"0=1\")")
% "Unknown."
% OMEGA(10): (serv~apply "PVS" "provects(\"FORALL (y:real): 
% continuous(LAMBDA (x: real): 1 / (cos(x) + 2), y)\")")

   catch E then 
      {Browse E}
      {PVSService leave}
   end
%   {App.exit 0}
end


         
         
         
         
         
