%%
%%  a test program for Alexander
%%

functor
   
import
   XApplication
   at 'x-ozlib://mathweb/share/XApplication.ozf'
   
   Browser(browse: Browse)
   
   BrokerAccess(getBroker)
   at 'x-ozlib://mathweb/sys/BrokerAccess.ozf'
   
define
   App     = {New XApplication.manager init}
   AppName = "testspass"
   %% The command line arguments
   DefaultTicket = "http://www.mathweb.org/~jzimmer/broker@goedel"
   Spec = record(brokerticket(single type:string default: DefaultTicket))

Args
   try
      Args = {App.getCmdArgs Spec}
   catch error(ap(usage S)...) then
      {App.showError AppName#': '#S}
      {App.exit 1}
   end
   %% end of args
   
   Broker = {BrokerAccess.getBroker App Args}.send
   
   Spass = {Broker request("SPASS" $)}
   
   Problem = "begin_problem(Pelletier54).
list_of_descriptions.
name({*Pelletier\'s Problem No. 54*}).
author({*Christoph Weidenbach*}).
status(unsatisfiable).
description({*Problem taken in revised form from
              the \"Pelletier Collection\",
              Journal of Automated Reasoning, Vol. 2, No. 2, pages 191-216*}).
end_of_list.

list_of_symbols.
  predicates[(F,2)].
end_of_list.

list_of_formulae(axioms).
  formula(forall([U],exists([V],forall([W],equiv(F(W,V),equal(W,U)))))).
end_of_list.

list_of_formulae(conjectures).
  formula(not(exists([U],forall([V],equiv(F(V,U),forall([W],implies(F(V,W),exists([X],and(F(X,W),not(exists([Y],and(F(Y,W),F(Y,X))))))))))))).

end_of_list.

end_problem."

%       meth prove(ProblemBS ?Result
% 		 syntax: Syntax <= unit
% 		 times:  ?Times <= _
% 		)
   VS2BS = VirtualString.toByteString

   Result 
   {Spass enter}
   {Spass prove({VS2BS Problem} ?Result
		syntax: dfg
                replyWith: result(state: unit
                                  name: unit
                                  host: unit
                                  times: unit
                                  output: unit)
               )}
   {Wait Result}
   {Browse Result}
%% Result is a record
%%     s(string: Proof      % the proof!
%%       bool:   Failed?    % boolean indicating if the prover is failed 
%%       host:   self.host) % name of the host the prover runs on

   {Spass leave}

%   {App.exit 0}
end


