%%%
%%% WALDMEISTER agent
%%%

functor
   
import
   OS(getEnv)

   XService(manager: ServiceManager)
   at 'x-ozlib://mathweb/sys/XService.ozf'
   ShellProverClass('class': ShellProver)
   at 'x-ozlib://mathweb/sys/ShellProver.ozf'

   XApplication
   at 'x-ozlib://mathweb/share/XApplication.ozf'
   
%   File
%   at 'x-ozlib://mathweb/share/File.ozf'
define
   AppName     = 'waldmeister'
   ServiceName = 'WALDMEISTER'
   App         = {New XApplication.manager init}

   ProofSignal = "****************************** COMPLETION - PROOF ******************************"
   ProofBegin  = "Consider the following set of axioms:"
   
   WALDMEISTER = {OS.getEnv "WALDMEISTERHOME"}
   
   class WaldmeisterService from ShellProver
      feat
         name: waldmeister
         
      meth submitProblem(ProblemBS...)
         WaldIn  = "wald.in"  %{OS.tmpnam}
         WaldOut = "wald.out" %{OS.tmpnam}
         {self saveVS(ProblemBS WaldIn)}
         CallWald = WALDMEISTER#" --auto --details "#WaldIn#" >"#WaldOut#" 2>&1"
      in
         {self start(CallWald)}
      end
      
      meth analyzeResult($)
         F
         proc {Skip}
            case {F getS($)}
            of false       then skip
            [] !ProofBegin then skip
            else {Skip}
            end
         end
         
         fun {ProofFound}
            case {F getS($)}
            of false        then undetermined
            [] !ProofSignal then proof
%              [] "..."        then false
            else {ProofFound}
            end
         end
         
         fun {Take}
            case {F getS($)}
            of false    then nil
            elseof Line then Line#"\n"#{Take}
            end
         end
      in
         try
	    State Result
         in
            F = {self openRead("wald.out" $)}
            State = {ProofFound}
            if State == proof then {Skip} end
            
            Result = atp_result(state: State
                                name: self.name
                                host: self.host
                                output: (if State == proof then ProofBegin#"\n" else nil end)#{Take}
                               )
            {F close}
            Result
	 catch _ then Output in
	    try
               Output = {self readAll(F $)}
               {F close}
            catch _ then skip end
	    atp_result(state: error
                       name:  self.name
                       host:  self.host
                       output: if {IsDet Output} then Output else nil end
                      )
	 end
      end
   end
   
   ServMan = {New ServiceManager init(ServiceName WaldmeisterService
                                      appName: AppName
                                      appMan:  App)}
   {ServMan offerService}
   {App.exit 0}
end

%       meth submitProblem(ProblemBS...)
%          WaldIn  = "wald.in"  %{OS.tmpnam}
%          WaldOut = "wald.out" %{OS.tmpnam}
%          {self saveVS(ProblemBS WaldIn)}
%          CallWald = WALDMEISTER#" --auto --details "#WaldIn#" >"#WaldOut
%       in
%          {self start(CallWald)}
%       end
      
%       meth analyzeResult($)
%          Proof Failed
%          local
%             F = {self openRead("wald.out" $)}

%             proc {Skip}
%                case {F getS($)}
%                of false       then skip
%                [] !ProofBegin then skip
%                else {Skip}
%                end
%             end
            
%             fun {ProofFound}
%                case {F getS($)}
%                of false        then unknown
%                [] !ProofSignal then true
% %              [] "..."        then false
%                else {ProofFound}
%                end
%             end
%             ProofOk = {ProofFound}
            
%             fun {Take}
%                case {F getS($)}
%                of false    then nil
%                elseof Line then Line#"\n"#{Take}
%                end
%             end
% 	 in
% 	    Failed? = {Member ProofOk [false error unknown]}
% 	    case ProofOk
%             of true    then {Skip} Proof = ProofBegin#'\n'#{Take}
%             [] false   then Proof = "-------------------------------\n"
%             [] error   then Proof = "syntax error\n"
% 	    [] unknown then Proof = "unknown result\n"
%             end
%             {F close}
%          end
%       in
%          s(string:{ByteString.make Proof} bool:Failed? host:self.host)
%       end
%    end
