%%%
%%% COCOA agent
%%%

functor
   
import
   System(printInfo) OS(getEnv getCWD chDir)
   
   CasService('class': CASService)
   at 'x-ozlib://mathweb/sys/CasService.ozf'
   XService(manager: ServiceManager)
   at 'x-ozlib://mathweb/sys/XService.ozf'
   XApplication
   at 'x-ozlib://mathweb/share/XApplication.ozf'
   
define
   AppName     = 'cocoa'
   ServiceName = 'COCOA'
   App         = {New XApplication.manager init}

   COCOA_DIR   = {OS.getEnv 'COCOA_LIBRARY'}
   Cmd         = {OS.getEnv 'COCOA'}
   Args        = nil

   if COCOA_DIR==false then
      raise undefinedVariable('COCOA_LIBRARY') end
   end
   if Cmd==false then
      raise undefinedVariable('COCOA') end
   end

   VS2BS = VirtualString.toByteString
   
   fun {DropSpaces S} {List.dropWhile S Char.isSpace} end
   fun {Clear S} {Reverse {DropSpaces {Reverse {DropSpaces S}}}} end
   %%fun {MkError S} error({VS2BS S}) end
   
   class CocoaService from CASService
      
      meth startCAS
         %% not threadsafe
         CurrentDir = {OS.getCWD} in
         {OS.chDir COCOA_DIR}
         CASService, startCAS(cmd:Cmd args:Args
                              suffix: ";\n"
                              prompts: ["-------------------------------\n"]
                              subst: ["------------------------------------------"#""]
                              printInfo: System.printInfo)
         {OS.chDir CurrentDir}
      end
      /*
      meth preProcess(ExprVS $)
         ExprVS
      end
      */
      %% The following method post-processes the cocoa's output.
      %% S originally contains everything except the prompt,
      %% with all the substitutions already performed.
      %%
      meth postProcess(S $) 
         {VS2BS {Clear S}}
      end
   end
  
   ServMan = {New ServiceManager init(ServiceName CocoaService
                                      appName: AppName
                                      appMan:  App)}
   {ServMan offerService}
   {App.exit 0}
end






