%%%
%%% GAP agent
%%%

functor
   
import
   System(printInfo) OS(getEnv)
   
   CasService('class': CASService)
   at 'x-ozlib://mathweb/sys/CasService.ozf'
   XService(manager: ServiceManager)
   at 'x-ozlib://mathweb/sys/XService.ozf'
   XApplication
   at 'x-ozlib://mathweb/share/XApplication.ozf'
   
define
   AppName     = 'gap'
   ServiceName = 'GAP'
   App         = {New XApplication.manager init}

   Cmd         = {OS.getEnv 'GAPHOME'}
   Args        = ['-r']

   if Cmd==false then
      raise undefinedVariable('GAPHOME') end
   end

   VS2BS = VirtualString.toByteString
   
   fun {DropSpaces S} {List.dropWhile S Char.isSpace} end
   fun {Clear S} {Reverse {DropSpaces {Reverse {DropSpaces S}}}} end
   %%fun {NoNewlineOrBackslash C} C\=&\n andthen C\=&\\ end
   fun {IsAlphaOrSpace C} {Char.isAlpha C} orelse {Char.isSpace C} end
   fun {MkError S} error({VS2BS S}) end
   
   class GapService from CASService
                       
      meth startCAS
         CASService, startCAS(cmd:Cmd args:Args
                              suffix: ";\n"
                              prompts: ["gap> "]
                              subst:  ["\\\n"#"" "\nbrk> "#"\ngap> "]
			      printInfo: System.printInfo)
      end
      /*
      meth preProcess(ExprVS $)
         ExprVS
      end
      */
      meth postProcess(S $)
         case {Reverse S} of &^|_ then {MkError S}
         elsecase {List.dropWhile S IsAlphaOrSpace} of &:|& |_ then {MkError S}
         else
            {VS2BS {Clear S}}
         end
      end
   end
  
   ServMan = {New ServiceManager init(ServiceName GapService
                                      appName: AppName
                                      appMan:  App)}
   {ServMan offerService}
   {App.exit 0}
end






