%%%
%%% MAGMA agent
%%%

functor
   
import
   System(printInfo) OS(getEnv)
   
   CasService('class': CASService)
   at 'x-ozlib://mathweb/sys/CasService.ozf'
   XService(manager: ServiceManager)
   at 'x-ozlib://mathweb/sys/XService.ozf'
   XApplication
   at 'x-ozlib://mathweb/share/XApplication.ozf'
   
define
   AppName     = 'magma'
   ServiceName = 'MAGMA'
   App         = {New XApplication.manager init}
   
   Cmd         = {OS.getEnv 'MAGMAHOME'}
   Args        = ['-b']
   
   if Cmd==false then
      raise undefinedVariable('MAGMAHOME') end
   end
   
   VS2BS = VirtualString.toByteString
   
   fun {DropSpaces S} {List.dropWhile S Char.isSpace} end
   fun {Clear S} {Reverse {DropSpaces {Reverse {DropSpaces S}}}} end
   fun {MkError S} error({VS2BS S}) end
   
   class MagmaService from CASService
      
      meth startCAS
         CASService, startCAS(cmd:Cmd args:Args
                              suffix: ";\n"
                              prompts: ["\n"]
                              subst:  ["\\\n"#""]
                              hasPrompt: false
                              printInfo: System.printInfo)
      end
      /*
      meth preProcess(ExprVS $)
         ExprVS
      end
      */
      meth postProcess(S $)
         case S of nil then
            {MkError &\n|CASService,readRest($)}
         [] &\n|&>|&>|_ then
            {MkError S#CASService,readRest($)}
         else
            {VS2BS {Clear S}}
         end
      end
   end
  
   ServMan = {New ServiceManager init(ServiceName MagmaService
                                      appName: AppName
                                      appMan:  App)}
   {ServMan offerService}
   {App.exit 0}
end






