%%%
%%% POST / MAPLE translator agent
%%%

functor
   
import
   OS(getEnv)

   XService(manager: ServiceManager)
   at 'x-ozlib://mathweb/sys/XService.ozf'
   ShellProverClass('class': ShellProver)
   at 'x-ozlib://mathweb/sys/ShellProver.ozf'

   XApplication
   at 'x-ozlib://mathweb/share/XApplication.ozf'
   
define
   AppName     = 'mapletrans'
   ServiceName = 'MAPLETRANS'
   App         = {New XApplication.manager init}
   
   POST2MAPLE = {OS.getEnv 'POST2MAPLE'}
   MAPLE2POST = {OS.getEnv 'MAPLE2POST'}

   if POST2MAPLE==false
   then raise undefinedVariable('POST2MAPLE') end
   else {App.showInfo  "$POST2MAPLE = "#POST2MAPLE}
   end
   if MAPLE2POST==false
   then raise undefinedVariable('MAPLE2POST') end
   else {App.showInfo  "$MAPLE2POST = "#MAPLE2POST}
   end
   
   fun {IsSpace C} {Char.isSpace C} orelse C==&\n end
   fun {DropSpaces S} {List.dropWhile S IsSpace} end
   fun {Clear S} {Reverse {DropSpaces {Reverse {DropSpaces S}}}} end
   
   class MapleService from ShellProver
                         
      meth CallPost2Maple(PostVS ?MapleS) 
	 {self saveVS(PostVS 'post2maple.in')}
	 {self exec(POST2MAPLE#' -f < post2maple.in > post2maple.out'
		    nice:false)}
	 {self loadS('post2maple.out' ?MapleS)}
      end
      meth CallMaple2Post(MapleVS ?PostS)
         {self saveVS(MapleVS 'maple2post.in')}
         {self exec(MAPLE2POST#' -f < maple2post.in > maple2post.out'
                    nice:false)}
         {self loadS('maple2post.out' ?PostS)}
      end         
      
      meth post2maple(PostVS ?MapleS)
	 {App.showInfo "[post2maple] input:  "#PostVS}
         MapleS = {Clear {Filter {self CallPost2Maple(PostVS#"\n" $)}
                          fun {$ C} C\=0 end}}
         {App.showInfo "[post2maple] output: "#MapleS}
      end
      meth maple2post(MapleVS ?PostS)
	 {App.showInfo "[maple2post] input:  "#MapleVS}
         PostS = {Clear {Filter {self CallMaple2Post(MapleVS#";\n" $)}
                         fun {$ C} C\=0 end}}
	 {App.showInfo "[maple2post] output: "#PostS}
      end
      
   end
  
   ServMan = {New ServiceManager init(ServiceName MapleService
                                      appName: AppName
                                      appMan:  App)}
   {ServMan offerService}
   {App.exit 0}
end
