
%%
%% LOUI dialogs
%%

functor

import
   Open(text file)
   OS(getDir stat unlink)
   Resolve(localize)
   Tk
   TkTools
   
   System
%   Browser(browse: Browse)
   
   XTkTools(textlistbox
	    helpButton
	    helpButtonText)
   at 'x-ozlib://mathweb/share/XTkTools.ozf'
   XTkDialog
   at 'x-ozlib://mathweb/share/XTkDialog.ozf'

export
   HostDialog
   ServiceDialog
   URLDialog
define
   
   VS2A = VirtualString.toAtom
   A2S = Atom.toString
   MapInd = List.mapInd
   ForAllInd = List.forAllInd

   LineLength = 70
   %%
   %% command suggestions
   %%
   class HostDialog
      from TkTools.dialog

      feat
	 manager
	 Name
	 User
	 Method
	 OS
	 WWW
      meth init(master        : Master
		status        : Status
		manager       : Manager
		title         : Title
		info          : Info
		symbolDir     : SymbolDir
		change        : Change        <= true
		result        : ?Result)
	    
	 proc {OK}
	    HostName = if Change then
			  {VS2A {self.Name tkReturn(get $)}}
		       else
			  {Label Info}
		       end
	    UserE = if {HasFeature Info login} then
		       {self.User tkReturn(get $)}
		    else "bar" end
	    {System.show hallo1(Info)}
	    MethodE = {self.Method tkReturn(get $)}
	    {System.show hallo2(MethodE)}
	    OSType = if {HasFeature Info ostype} then
			{self.OS tkReturn(get $)}
		     else "dummy" end
	    
	    WWWE = {self.WWW tkReturn(get $)}
	    {System.show hallo2}
	 in
	    if Change andthen HostName == nil then
	       if {Not {self confirm("You have to spcify a hostname!" $)}} then
		  Result = nil
		  {self tkClose}
	       end
	    elseif MethodE == nil then
	       if {Not {self confirm("You have to spcify a login command!" $)}} then
		  Result = nil
		  {self tkClose}
	       end
	    elseif OSType == nil then
	       if {Not {self confirm("You have to spcify an operating system type!" $)}} then
		  Result = nil
		  {self tkClose}
	       end
	    elseif WWWE == nil then
	       if {Not {self confirm("You have to spcify www server!" $)}} then
		  Result = nil
		  {self tkClose}
	       end
	    else  
	       {System.show hallo3}
	       Result = if {HasFeature Info services} then
			   HostName(method: MethodE
				    services: Info.services
				    ostype: OSType
				    www: WWWE)
			else
			   HostName(login: UserE
				    method: MethodE
				    www: WWWE)
			end
	       {self tkClose}
	    end
	 end
	    
	 proc {Clear}
	    if Change then
	       {self.Name tk(delete 0 'end')}
	    end
	    {self.Method tk(delete 0 'end')}
	    {self.OS tk(delete 0 'end')}
	    {self.WWW tk(delete 0 'end')}
	 end
	    
	 proc {Cancel}
	    Result = nil
	    {self tkClose}	       
	 end
 
	 TkTools.dialog,tkInit(master:  Master
			       title:   Title
			       buttons: ['OK'  #OK
					 'Clear' #Clear
					 'Cancel'#Cancel]
			       focus:   1
			       pack:    false
			       default: 1)
	    
	 NameFrame = {New Tk.frame tkInit(parent: self)}
	    
	 NameMessage = {New Tk.message tkInit(parent: NameFrame
					      aspect: 1000
					      text  : "Hostname:")}
	    
	 NameEntry = if Change then
			{New Tk.entry tkInit(parent: NameFrame
					     bg    :     wheat
					     width :  25)}
		     else
			{New Tk.message tkInit(parent: NameFrame
					       aspect: 1000
					       text  : {A2S {Label Info}})}
		     end
	 UserFrame = {New Tk.frame tkInit(parent: self)}
	 UserMessage = {New Tk.message tkInit(parent: UserFrame
					      aspect: 1000
					      text  : "Login as user: ")}
	 UserEntry = {New Tk.entry tkInit(parent: UserFrame
					   bg    :     wheat
					   width :  15)}

	 MethodFrame = {New Tk.frame tkInit(parent: self)}
	 MethodMessage = {New Tk.message tkInit(parent: MethodFrame
					       aspect: 1000
					       text  : "Login command: ")}
	 MethodEntry = {New Tk.entry tkInit(parent: MethodFrame
					   bg    :     wheat
					   width :  20)}
	 
	 OSFrame = {New Tk.frame tkInit(parent: self)}
	 OSMessage = {New Tk.message tkInit(parent: OSFrame
					    aspect: 1000
					    text  : "OS-type: ")}
	 OSEntry = {New Tk.entry tkInit(parent: OSFrame
					bg    : wheat
					width :  25)}

	 WWWFrame = {New Tk.frame tkInit(parent: self)}
	 WWWMessage = {New Tk.message tkInit(parent: WWWFrame
					     aspect: 1000
					     text  : "WWW-server: ")}
	 WWWEntry = {New Tk.entry tkInit(parent: WWWFrame
					bg    : wheat
					width :  22)}
 	    
% 	    Choose = {New XTkTools.helpButtonText init(parent : NameFrame
% 						       status : Status
% 						       action : self # ok
% 						       text   : ButtonText
% 						       help   : HelpText
% 						       message: HelpMessage)}
      in
	 self.manager = Manager
	 self.User = UserEntry
	 self.Name = NameEntry
	 self.Method = MethodEntry
	 self.OS = OSEntry
	 self.WWW = WWWEntry
	    
% 	    if Change then
% 	       {NameEntry tk(delete 0 'end')}
% 	       {NameEntry tk(insert 0 {A2S {Label Info}})}
% 	    end
	 
	 {UserEntry tk(delete 0 'end')}
	 if {HasFeature Info login} then
	    {UserEntry tk(insert 0 Info.login)}
	 end
	 
	 {MethodEntry tk(delete 0 'end')}
	 {MethodEntry tk(insert 0 Info.method)}
	 
	 {OSEntry tk(delete 0 'end')}
	 if {HasFeature Info ostype} then
	    {OSEntry tk(insert 0 Info.ostype)}
	 end

	 {WWWEntry tk(delete 0 'end')}
	 {WWWEntry tk(insert 0 Info.www)}
	    
	 if {HasFeature Info ostype} then
	    {Tk.batch [
		       pack(NameMessage NameEntry side:left padx:2)
		       pack(NameMessage NameFrame side:left anchor:w padx:2)
		       pack(MethodMessage MethodEntry side:left padx:2)
		       pack(MethodMessage MethodFrame side:left anchor:w padx:2)
		       pack(OSMessage OSEntry side:left padx:2)
		       pack(OSMessage OSFrame side:left anchor:w padx:2)
		       pack(WWWMessage WWWEntry side:left padx:2)
		       pack(WWWMessage WWWFrame side:left anchor:w padx:2)
		      ]}
	    
	    {Tk.batch [grid(NameFrame   row: 0 column: 0  sticky:nswe)
		       grid(MethodFrame row: 1 column: 0  sticky:nswe)
		       grid(OSFrame     row: 2 column: 0  sticky:nswe)
		       grid(WWWFrame    row: 3 column: 0  sticky:nswe)
		       focus(NameEntry)
		      ]}
	 else
	    {Tk.batch [
		       pack(NameMessage NameEntry side:left padx:2)
		       pack(NameMessage NameFrame side:left anchor:w padx:2)
		       pack(UserMessage UserEntry side:left padx:2)
		       pack(UserMessage UserFrame side:left anchor:w padx:2)
		       pack(MethodMessage MethodEntry side:left padx:2)
		       pack(MethodMessage MethodFrame side:left anchor:w padx:2)
		       pack(WWWMessage WWWEntry side:left padx:2)
		       pack(WWWMessage WWWFrame side:left anchor:w padx:2)
		      ]}
	    
	    {Tk.batch [grid(NameFrame   row: 0 column: 0  sticky:nswe)
		       grid(UserFrame   row: 1 column: 0  sticky:nswe)
		       grid(MethodFrame row: 2 column: 0  sticky:nswe)
		       grid(WWWFrame    row: 3 column: 0  sticky:nswe)
		       focus(NameEntry)
		      ]}
	 end
	 HostDialog,tkPack
      end
      meth confirm(Text ?Result)
	 {Wait
	  {New XTkDialog.confirm init(master: self.toplevel
				      aspect: 400
				      title: "Please confirm"
				      text : Text
				      result: ?Result)}.tkClosed}
      end
   end


   class ServiceDialog
      from TkTools.dialog
	 
      feat
	 manager
	 isLinux
	 isSolaris

	 Linux
	 Solaris
	 
      meth init(master        : Master
		status        : Status
		manager       : Manager
		title         : Title
		heading       : Heading
		info          : Info
		symbolDir     : SymbolDir
		change        : Change        <= true
		result        : ?Result)
	    
	 proc {OK}
	    ServiceName = {Label Info}
	    LinuxE = {Map self.Linux fun{$ W} {W tkReturn(get $)} end}
	    SolarisE = {Map self.Solaris fun{$ W} {W tkReturn(get $)} end}
	 in
	    if self.isLinux andthen {Member nil LinuxE} then
	       if {Not {self confirm("You have give an entry for each variable!" $)}} then
		  Result = nil
		  {self tkClose}
	       end
	    elseif  self.isSolaris andthen {Member nil SolarisE} then
	       if {Not {self confirm("You have give an entry for each variable!" $)}} then
		  Result = nil
		  {self tkClose}
	       end
	    else		  
	       Result = ServiceName(vars:  Info.vars
				    linux: LinuxE
				    solaris: SolarisE
				    type: Info.type
				    help: Info.help
				    ostypes: Info.ostypes)
	       {self tkClose}
	    end
	 end
	 
	 proc {Clear}
	    {ForAll self.Linux
	     proc{$ Entry}
		{Entry tk(delete 0 'end')}
	     end}
	    {ForAll self.Solaris
	     proc{$ Entry}
		{Entry tk(delete 0 'end')}
	     end}
	 end
	 
	 proc {Cancel}
	    Result = nil
	    {self tkClose}	       
	 end
	 
	 self.isLinux = {Member "linux" Info.ostypes}
	 self.isSolaris = {Member "solaris" Info.ostypes}
	 
	 TkTools.dialog,tkInit(master:  Master
			       title:   Title
			       buttons: ['OK'  #OK
					 'Clear' #Clear
					 'Cancel'#Cancel]
			       focus:   1
			       pack:    false
			       default: 1)
	 
	 NameFrame = {New Tk.frame tkInit(parent: self)}
	 
	 NameMessage = {New Tk.message tkInit(parent: NameFrame
					      aspect: 1000
					      text  : Heading
					      fg: red)}
	 
	 NameEntry = {New Tk.message tkInit(parent: NameFrame
					    aspect: 1000
					    text  : {A2S {Label Info}}
					    fg: red)}

	 FirstFrame = {New Tk.frame tkInit(parent: self)}
	 
	 FirstMessage = {New Tk.message tkInit(parent: FirstFrame
					       aspect: 1000
					       text  : "Settings for Linux:")}
	 SecondFrame = {New Tk.frame tkInit(parent: self)}
	 
	 SecondMessage = {New Tk.message tkInit(parent: SecondFrame
						aspect: 1000
						text  : "Settings for Solaris:")}
	 
	 
	 Vars = Info.vars
	 Lengths = {Map Vars fun{$ Ls}
				L = {Length Ls} in
				if L>20 then 0
				else
				   20 - L +((20 - L) div 2)
				end
			     end}
	 LinuxFrames 
	 LinuxMessages
	 LinuxEntries
	 
	 if self.isLinux then
	    LinuxFrames = {Map Info.linux fun{$ _}
					     {New Tk.frame tkInit(parent: self)}
					  end}
	    LinuxMessages = {MapInd LinuxFrames
			     fun{$ I Frame}
				{New Tk.message tkInit(parent: Frame
						       width : 200
						       aspect: 1000
						       text  : {Nth Vars I})}
			     end}
	    LinuxEntries = {MapInd LinuxFrames
			    fun{$ I Frame}
			       {New Tk.entry tkInit(parent: Frame
						    bg    : wheat
						    width : LineLength+{Nth Lengths I})}
			    end}
	 else 
	    LinuxFrames = nil
	    LinuxMessages = nil
	    LinuxEntries = nil
	 end

	 SolarisFrames 
	 SolarisMessages
	 SolarisEntries
	 
	 if self.isSolaris then
	    SolarisFrames = {Map Info.solaris fun{$ _}
					     {New Tk.frame tkInit(parent: self)}
					  end}
	    SolarisMessages = {MapInd SolarisFrames
			     fun{$ I Frame}
				{New Tk.message tkInit(parent: Frame
						       aspect: 1000
						       text  : {Nth Vars I})}
			     end}
	    SolarisEntries = {MapInd SolarisFrames
			      fun{$ I Frame}
				 {New Tk.entry tkInit(parent: Frame
						      bg    : wheat
						      width : LineLength+{Nth Lengths I})}
			      end}
	 else 
	    SolarisFrames = nil
	    SolarisMessages = nil
	    SolarisEntries = nil
	 end
      in
	 self.Linux = LinuxEntries
	 self.Solaris = SolarisEntries

	 {Tk.batch [
		    pack(NameMessage NameEntry side:left)
		    pack(NameMessage NameFrame side:left anchor:w )
		    
		    pack(FirstMessage FirstFrame side:left anchor:w padx:0)
		    pack(SecondMessage SecondFrame side:left anchor:w padx:1)
		   ]}
	 
	 {ForAllInd LinuxEntries
	  proc{$ I Entry}
	     {Entry tk(delete 0 'end')}
	     {Entry tk(insert 0 {Nth Info.linux I})}
	     {Tk.batch [pack({Nth LinuxMessages I} {Nth LinuxEntries I} side:left padx:2)
			pack({Nth LinuxMessages I} {Nth LinuxFrames I} side:left anchor:w padx:2)]}
	     
	  end}
	 {ForAllInd SolarisEntries
	  proc{$ I Entry}
	     {Entry tk(delete 0 'end')}
	     {Entry tk(insert 0 {Nth Info.solaris I})}
	     {Tk.batch [pack({Nth SolarisMessages I} {Nth SolarisEntries I} side:left padx:2)
			pack({Nth SolarisMessages I} {Nth SolarisFrames I} side:left anchor:w padx:2)]}
	     
	  end}
	 
	 {Tk.batch [grid(NameFrame   row: 0 column: 0  sticky:nswe)
		    grid(FirstFrame  row: 1 column: 0  sticky:nswe)
		    grid(SecondFrame row: 2 column: 0  sticky:nswe)
		   ]}
	 {Tk.batch {MapInd LinuxFrames
		    fun{$ I Frame}
		       grid(Frame  row: I+1 column: 1  sticky:nswe)
		    end}}
	 {Tk.batch [grid(SecondFrame row: {Length LinuxFrames}+2 column: 0  sticky:nswe)
		   ]}
	 {Tk.batch {MapInd SolarisFrames
		    fun{$ I Frame}
		       grid(Frame  row: I+{Length LinuxFrames}+4 column: 1  sticky:nswe)
		    end}}
	 ServiceDialog,tkPack
      end
      meth confirm(Text ?Result)
	 {Wait
	  {New XTkDialog.confirm init(master: self.toplevel
				      aspect: 400
				      title: "Please confirm"
				      text : Text
				      result: ?Result)}.tkClosed}
      end
   end


   %%
   %% URL dialog
   %%
   local
      MyUrlMessage  = 'Enter the URL or local location of the configuration file you would like to open'
      MyButtonText  = 'Choose File...'
      MyHelpText    = 'Choose local file'
      MyHelpMessage = 'Choose local file to open.'
   in
      class URLDialog
	 from TkTools.dialog
	    
	 feat
	    manager
	    entry
	    load
	    
	 meth init(master        : Master
		   status        : Status
		   manager       : Manager
		   title         : Title
		   info          : Info
		   suffix        : Suffix
		   load          : Load
		   confirm       : Confirm
		   initurl       : URL           <= nil
		   urlMessagge   : UrlMessage    <= MyUrlMessage
		   buttonText    : ButtonText    <= MyButtonText
		   helpText      : HelpText      <= MyHelpText
		   helpMessage   : HelpMessage   <= MyHelpMessage
		   file          : ?File)
            
	    proc {Open}
	       File = {self.entry tkReturn(get $)}
	       {self tkClose}
	    end
            
	    proc {Clear}
	       {self.entry tk(delete 0 'end')}
	    end
            
	    proc {Cancel}
	       File = false
	       {self tkClose}
	    end
	    
	    TkTools.dialog,tkInit(master:  Master
				  title:   Title
				  buttons: [Confirm  #Open
					    'Clear' #Clear
					    'Cancel'#Cancel]
				  focus:   1
				  pack:    false
				  default: 1)
	    
	    URLFrame = {New Tk.frame tkInit(parent: self)}
	    
	    URLMessage = {New Tk.message tkInit(parent: URLFrame
						aspect: 1000
						text  : UrlMessage)}
	    
	    EntryFrame = {New Tk.frame tkInit(parent: URLFrame)} 
	    
	    URLEntry = {New Tk.entry tkInit(parent: EntryFrame
					    bg    :     wheat
					    width :  60)}
            
	    Choose = {New XTkTools.helpButtonText init(parent : EntryFrame
						       status : Status
						       action : self # chooseFile(Title Info Suffix)
						       text   : ButtonText
						       help   : HelpText
						       message: HelpMessage)}
	 in
	    self.manager = Manager
	    self.entry   = URLEntry
            self.load    = Load
	    {URLEntry tk(delete 0 'end')}
	    {URLEntry tk(insert 0 URL)}
            
	    {Tk.batch [pack(URLEntry Choose side:left padx:2)
		       pack(URLMessage EntryFrame side:top anchor:w pady:2)
		       pack(URLFrame)
		       focus(URLEntry)]}
	    URLDialog,tkPack
	 end
	 
	 
	 meth chooseFile(Title Info Suffix)
	    
	    Filename
	 in
	    if self.load then
	       {self.manager loadFilebox(Title Info Suffix ?Filename)}
	    else
	       {self.manager saveFilebox(Title Info Suffix ?Filename)}
	    end
	    if Filename==false then
	       skip
	    else
	       {self.entry tk(delete 0 'end')}
	       {self.entry tk(insert 0 Filename)}
	    end
	 end      
      end 
   end

end %define
