%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% ToplevelManager.oz ; This file is part of the MathWeb system
%
%   major updates: 20.12.2000
%
%   Authors: Juergen Zimmer
%
%   email: jzimmer@ags.uni-sb.de
%   
% For information about this program, write to:                          
%   MathWeb-Project                                                        
%   AG Siekmann/FB nformatik                                            
%   Universitaet des Saarlandes                                          
%   Bau 36, 4. Stock                                                     
%   D-66041 Saarbruecken                                                 
%   Germany    
%
% For information about the newest version of MathWeb, see 
%   http://www.mathweb.org/mathweb
%
% See the file "LICENSE" or
%    http://www.mathweb.org/mathweb/LICENSE.html
% for information on usage and redistribution
% of this file, and for a DISCLAIMER OF ALL
% WARRANTIES.
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

functor
import
   TkTools
   Tk
    
%   System
%   Browser(browse:Browse)

   XTkTools
   at 'x-ozlib://mathweb/share/XTkTools.ozf'
   XTkDialog
   at 'x-ozlib://mathweb/share/XTkDialog.ozf'

export
   'class':ToplevelManager
define
   WindowTitle = 'The MathWeb Configuration Tool V1.0b'
   
   A2S = Atom.toString
   local
      
      class TextListBox
	 from XTkTools.textlistbox
	 attr popupMenu
	 meth bindMenu(Master MenuItems Button Method $)
	    M ={New Tk.menu tkInit(parent:self  tearoff:false)}
	    popupMenu <- record()
	    {ForAll MenuItems
	     proc {$ C}
		Comm ={New Tk.menuentry.command
		       tkInit(parent:M label:C 
			      action: proc{$}
					 I = {self.listbox tkReturn(curselection $)}
					 S = case I
					     of nil then nil
					     else
						{self.listbox
						 tkReturn(get(I) $)}
					     end
				      in
					 {Master Method(C S)} end
			     )}
	     in
		popupMenu <-{AdjoinAt @popupMenu {String.toAtom C} Comm}
	     end}
	 in
	    {self.listbox tkBind(event:  Button 
				 args:   [int(x) int(y)]
				 action: proc {$ X Y}
					    TX={Tk.returnInt winfo(rootx self)}
					    TY={Tk.returnInt winfo(rooty self)}
					 in 
					    {Tk.send tk_popup(M X+TX Y+TY)}
					 end)}
	    @popupMenu
	 end
	 meth getPopUpMenu(Master Method $)
	    {self
	     bindMenu(Master
		      ["Edit new" "Modify this" "Delete this"]
		      '<3>'  Method $)}
	 end
      end
      proc{DisablePopUp Class ListBox}
	 {Class.ListBox.'Delete this' tk(entryconfigure state:disabled)}
	 {Class.ListBox.'Modify this' tk(entryconfigure state:disabled)}
      end
%       proc{ActivatePopUp Class ListBox}
% 	 {Class.ListBox.'Delete this' tk(entryconfigure state:normal)}
% 	 {Class.ListBox.'Modify this' tk(entryconfigure state:normal)}
%       end
      
      class Toplevel
	 from Tk.toplevel            
	 feat
	    manager
	    frameBook
	 meth init(Manager Menu Symbol Status ?PackMe symbolDir: SymbolDir)
	    Tk.toplevel,
	    tkInit(title:WindowTitle withdraw: true highlightthickness: 0)
	    
	    {Tk.send wm(protocol self 'WM_DELETE_WINDOW' bell)}
	    self.manager = Manager
	    ConfigsFrame = {New  ConfigsBook
			    init(parent:self manager:Manager symbolDir: SymbolDir status: Status)}
	 in
	    self.frameBook = ConfigsFrame
	    proc {PackMe}
	       {Tk.batch [focus(self)
			  wm(resizable self 0 0)
			  wm(iconname self WindowTitle)
		    %wm(minsize self MinSizeX MinSizeY)
			  grid(Menu         row:0 column:0 columnspan:2 sticky:we)
			  grid(Symbol       row:1 column:0 columnspan:2 sticky:we)
			  grid(ConfigsFrame row:2 column:0              sticky:we)
			  grid(Status       row:3 column:0 columnspan:2 sticky:we)
			  grid(rowconfigure    self 4 weight:1.0)
			  grid(columnconfigure self 1 weight:1.0)
			  wm(deiconify         self)
		    %wm(geometry self StartSizeX#'x'#StartSizeY )
			 ]}
	    end
	 end

	 meth frameBook($)
	    self.frameBook
	 end
	
      end %of class
      
      class HostsFrame
	 from Tk.frame
	 prop locking
	 feat
	    manager

	    nameEntry
	    loginEntry
	    osEntry
	    servicesList
	    
	    hostsList
	    allServicesList
	    urlEntry
	    popupHost

         % buttons
            add
            addAll
            sub
            subAll

	 meth init(parent:Parent manager:Manager symbolDir:SymbolDir status: Status <= proc{$ _} skip end)

	    Tk.frame, tkInit(parent:Parent relief:raised bd:1)

 	    %%  HOSTS BUTTONS
	    ButtonFrame1  =  {New Tk.frame tkInit(parent: self
						  relief: groove
						  height: 66
						  borderwidth: 1)}
	    EditHostButton = {New XTkTools.helpButtonText         
			      init(parent : ButtonFrame1
			       status : Status
			       action : self # editEntry
			       text   : 'Edit Host'
			       help   : 'Edit Host'
			       message: 'Edit settings for selected host.')}
	    AddHostButton = {New XTkTools.helpButtonText         
			     init(parent : ButtonFrame1
				  status : Status
				  action : self # addEntry
				  text   : 'Add Host'
				  help   : 'Add Host'
				  message: 'Add entry for new host.')}
	    DelHostButton = {New XTkTools.helpButtonText         
			     init(parent : ButtonFrame1
				  status : Status
				  action : self # delEntry
				  text   : 'Del Host'
				  help   : 'Delete Host'
				  message: 'Delete entry for current host.')}

	    %%    HOSTS LIST
	    HostsFrame    = {New Tk.frame tkInit(parent: self
						 relief: groove
						 borderwidth: 1)}
	    
	    HostsListBox = {New TextListBox tkInit(title        : "Hosts: "
						   parent       : HostsFrame
						   height       : 13
						   width        : 10
						  )}
	    %%    HOSTINFO FRAME
 	    InfoFrame = {New Tk.frame tkInit(parent:self
					     relief: groove
					     height: 55
					     borderwidth: 1)}
	    
	    HostMessageFrame = {New Tk.frame tkInit(parent:InfoFrame
						    width: 20)}
	    HostMessage = {New Tk.message tkInit(parent: HostMessageFrame
						 text: "Host Info"
						)}
	    
	    LoginFrame     = {New Tk.frame tkInit(parent: InfoFrame)}
	    LoginLabel       = {New Tk.label tkInit(parent: LoginFrame    text:"Login command: ")}
	    LoginEntry       = {New Tk.entry tkInit(parent: LoginFrame   bg: white width: 10)}

	    OSFrame       = {New Tk.frame tkInit(parent: InfoFrame)}
	    OSLabel       = {New Tk.label tkInit(parent: OSFrame    text:"OS-type: ")}
	    OSEntry       = {New Tk.entry tkInit(parent: OSFrame   bg: white width: 15)}

	    NameFrame       = {New Tk.frame tkInit(parent: InfoFrame)}
	    NameLabel       = {New Tk.label tkInit(parent: NameFrame    text:"Hostname: ")}
	    NameEntry       = {New Tk.entry tkInit(parent: NameFrame   bg: white width: 15)}

	    
	    ServicesListBox = {New TextListBox tkInit(title        : "Host's Services: "
						      parent       : InfoFrame
						      height       :8
						      width        :15
						     )}
	    UrlFrame      =    {New Tk.frame tkInit(parent: self)}
	    UrlLabel        = {New Tk.label tkInit(parent: UrlFrame    text:"WWW-Server: ")}
	    UrlEntry        = {New Tk.entry tkInit(parent: UrlFrame    bg: white width: 40)}
	    %%   SERVICES BUTTONS
	    ButtonFrame2  =  {New Tk.frame tkInit(parent: self
						  relief: groove
						  borderwidth: 1 )}
	    AddAllButton = {New XTkTools.helpButton init(parent : ButtonFrame2
							 status : Status
							 action : self.manager # addAllServices
							 file   : 'suball.gif'
							 help   : 'Add All Services'
							 message: 'Add all services to the selected services.'
							 url    : SymbolDir
							)}
	    Space1 = {New Tk.frame tkInit(parent: ButtonFrame2
					  height: 32)}
	    Space2 = {New Tk.frame tkInit(parent: ButtonFrame2
					  height: 12)}
	    
	    SubAllButton = {New XTkTools.helpButton init(parent : ButtonFrame2
							 status : Status
							 action : self.manager # subAllServices
							 file   : 'addall.gif'
							 help   : 'Remove All Services'
							 message: 'Remove all services from the selected services.'
							 url    : SymbolDir
							)}
	    
	    
	    %%    AVAILABLE SERVICES FRAME
	    AllServicesFrame = {New Tk.frame tkInit(parent:self)}
	    AllServicesListBox = {New TextListBox tkInit(title        : "Available Services:  "
							 parent       : AllServicesFrame
							 height       :13
							 width        :15
							)}
	 in
	    self.manager      = Manager
	    self.hostsList    = HostsListBox 
	    self.nameEntry    = NameEntry
	    self.loginEntry    = LoginEntry
	    self.osEntry    = OSEntry
	    self.urlEntry     = UrlEntry
%            self.add        = AddButton
            self.addAll     = AddAllButton
 %           self.sub        = SubButton
            self.subAll     = SubAllButton
	    self.servicesList = ServicesListBox
	    self.allServicesList = AllServicesListBox

	    {self.hostsList  tkBind(event : '<1>'
				    action: proc{$}
					       Element = {self.hostsList getSelection($)}
					    in
					       {self updateHostInfo(Element)}
					    end)}
	    
	    {self.servicesList  tkBind(event : '<1>'
				       action: proc{$}
						  Element = {self.servicesList getSelection($)}
					       in
						  {self showServiceInfo(Element)}
					       end
				      )}
	    {self.allServicesList  tkBind(event : '<1>'
					  action: proc{$}
						     Element = {self.allServicesList getSelection($)}
						  in
						     {self showServiceInfo(Element)}
						  end
					 )}
	    {self.allServicesList  tkBind(event : '<Double-1>'
					  action: self # addService
					 )}
	    {self.servicesList  tkBind(event : '<Double-1>'
				       action: self # subService
				      )}
	    
	    self.popupHost    =  {self.hostsList getPopUpMenu(self replyToHost $)}

	    {Tk.batch [
		       grid(LoginLabel row: 0 column: 0 sticky:w)
		       grid(LoginEntry row: 0 column: 1 sticky:w)
		      ]}
	    {Tk.batch [
		       grid(NameLabel row: 0 column: 0 sticky:w)
		       grid(NameEntry row: 0 column: 1 sticky:w)
		      ]}
	    {Tk.batch [
		       grid(OSLabel row: 0 column: 0 sticky:w)
		       grid(OSEntry row: 0 column: 1 sticky:w)
		      ]}
	    {Tk.batch [
		       grid(UrlLabel row: 0 column: 0 sticky:w)
		       grid(UrlEntry row: 0 column: 1 sticky:w)
		      ]}
	    
	    {Tk.batch [
		       grid(ButtonFrame1     row: 0 column: 0 sticky: wsne)
		       grid(HostsFrame       row: 0 column: 1 rowspan: 5 sticky:nswe)
		       grid(InfoFrame        row: 0 column: 2 sticky: w)
		       grid(ButtonFrame2     row: 0 column: 3 rowspan: 3 sticky: wsne)
		       grid(AllServicesFrame row: 0 column: 4 rowspan: 3 sticky: nswe)
		       
		       grid(AddHostButton   row: 0 column: 0 sticky: w)
		       grid(EditHostButton  row: 1 column: 0 sticky: w)
		       grid(DelHostButton   row: 2 column: 0 sticky: w)
		       
		       grid(HostsListBox    row: 0 column: 1 sticky:nswe)
		       
		       grid(HostMessageFrame row: 0 column: 2 columnspan: 2 sticky: w)
		       grid(HostMessage row: 0 column: 2 columnspan: 2 sticky: w)
		       grid(NameFrame       row: 1 column: 2 columnspan: 3 sticky: w)
		       grid(LoginFrame      row: 2 column: 2 columnspan: 3 sticky: w)
		       grid(OSFrame         row: 3 column: 2 columnspan: 3 sticky: w)
		       grid(ServicesListBox row: 4 column: 2 sticky: w)
		       grid(UrlFrame        row: 5 column: 2 columnspan: 3 sticky: w)
		       
		       grid(Space1          row: 1 column: 0 sticky: w)
%		       grid(AddButton       row: 2 column: 2 sticky: w)
		       grid(AddAllButton    row: 2 column: 3 sticky: w)
		       grid(Space2          row: 3 column: 3 sticky: w)
%		       grid(SubButton       row: 5 column: 2 sticky: w)
		       grid(SubAllButton    row: 4 column: 3 sticky: w)

		       grid(AllServicesListBox row: 0 column: 4 rowspan: 3 sticky: nswe)
		      ]}
	    {DisablePopUp self 'popupHost'}
	    
	    {self.manager showHosts}
	    {self.manager showAvailableServices}
	 end
	 
	 
	 meth editEntry
	    Host = {self.hostsList getSelection($)}
	 in
	    if Host == false then skip
	    else
	       {self.manager editHostInfo(Host)}
	    end
	 end
	 meth delEntry
	    Host = {self.hostsList getSelection($)}
	 in
	    if Host == false then skip
	    else
	       {self.manager deleteHost(Host)}
	    end
	 end
	 meth addEntry
	    {self.manager addHost}
	 end
	 
	 
	 meth showServiceInfo(Element)
	    if Element==nil orelse Element == false then skip
	    else
	       {self.manager showServiceHelp(Element)}
	    end
	 end
	 
	 meth updateHostInfo(Element)
	    if Element==false then skip
	    else
	       {self.manager showHostInfo(Element)}
	    end
	 end

	 meth replyToHost(Method Entry)
	    {self.manager replyToMethod('Hosts'  Method Entry)}
	 end
	 
	 meth addService
	    Element = {self.allServicesList getSelection($)}
	 in
	    if Element == false then skip
	    else {self.manager addService(Element)}
	    end
	 end
	 meth subService
	    Element = {self.servicesList getSelection($)}
	 in
	    if Element == false then skip
	    else {self.manager subService(Element)}
	    end
	 end
	 
	 meth insertHosts(Hosts)
	    {self.hostsList clearElements}
	    {self.hostsList insertElements(Hosts)}      
	 end

	 meth showAvailableServices(Services)
	    lock
	       {self.allServicesList clearElements}
	       {self.allServicesList insertElements(Services)}
	    end		  
	 end

	 meth showHostInfo(Info)
	    lock
	       {self clear}
	       {self.nameEntry    tk(insert 0  {A2S {Label Info}})}
	       {self.osEntry      tk(insert 0  Info.ostype)}
	       {self.loginEntry   tk(insert 0  Info.method)}
	       {self.urlEntry     tk(insert 0  Info.www)}
	       {self.servicesList insertElementsInOrder(Info.services)}
	    end
	 end
	 
	 meth clear
	    {self.nameEntry tk(delete 0 'end')}
	    {self.loginEntry tk(delete 0 'end')}
	    {self.osEntry tk(delete 0 'end')}
	    {self.urlEntry tk(delete 0 'end')}
	    {self.servicesList clearElements}
	 end
      end

      class ServicesFrame
	 from Tk.frame
	 prop locking
	 feat
	    manager
	    status
	    servicesListBox
	    envBox
	    linuxListBox
	    solarisListBox
            
	 meth init(parent:Parent  manager:Manager symbolDir: SymbolDir status: Status <= proc{$ _} skip end)
	    Tk.frame, tkInit(parent: Parent)
	    ServicesFrame   = {New Tk.frame tkInit(parent:self)}
	    EnvFrame      = {New Tk.frame tkInit(parent:self)}
	    LinuxFrame      = {New Tk.frame tkInit(parent:self)}
	    SolarisFrame    = {New Tk.frame tkInit(parent:self)}
	    ButtonFrame  =  {New Tk.frame tkInit(parent: self)}
	    EditButton = {New XTkTools.helpButtonText         
			  init(parent : ButtonFrame
			       status : Status
			       action : self # editEntry
			       text   : 'Edit Entry'
			       help   : 'Edit'
			       message: 'Edit settings for selected service.')}
	    
	    ServicesListBox = {New TextListBox tkInit(title        : "Services:"
						      parent       : ServicesFrame
						      height       : 8
						      width        : 10
						     )}
	    EnvBox        = {New TextListBox tkInit(title        : "Variables:"
						    parent       : EnvFrame
						    height       : 5 
						    width        : 20
						   )}
	    LinuxEnvBox   = {New TextListBox tkInit(title        : "Linux Environment:"
						    parent       : LinuxFrame
						    height       : 5 
						    width        : 20
						   )}
	    SolarisEnvBox = {New TextListBox tkInit(title        : "Solaris Environment:"
						    parent       : SolarisFrame
						    height       : 5
						    width        : 20
						   )}
	 in
	    self.manager             = Manager
	    self.status              = Status
	    self.servicesListBox     = ServicesListBox
	    self.envBox        = EnvBox
	    self.linuxListBox        = LinuxEnvBox
	    self.solarisListBox      = SolarisEnvBox

	    {Tk.batch [grid(ServicesFrame    row: 0 column: 0 columnspan: 2 sticky:we)
		       grid(ButtonFrame      row: 0 column: 2 sticky:nswe)
		       grid(EnvFrame         row: 1 column: 1 sticky:nswe)
		       grid(LinuxFrame       row: 1 column: 2 sticky:nswe)
		       grid(SolarisFrame     row: 1 column: 3 sticky:nswe)
		       
		       grid(ServicesListBox  row:0 column:0 sticky:w)
		       grid(EditButton       row:0 column:2 sticky:w)
		       grid(EnvBox           row:1 column:1 sticky:w)
		       grid(LinuxEnvBox      row:1 column:2 sticky:w)
		       grid(SolarisEnvBox    row:1 column:3 sticky:w)
		      ]}
      
	    {self.servicesListBox  tkBind(event : '<1>'
				           action: proc{$}
						      Element = {self.servicesListBox getSelection($)}
						   in
						      {self updateServiceInfo(Element)}
						   end)}
	    {self.manager showServices}
	 end

	 meth editEntry
	    Element = {self.servicesListBox getSelection($)}
	 in
	    if Element \= false then
	       {self.manager editServiceInfo(Element)}
	    end
	 end
	 
	 meth updateServiceInfo(Element)
	    if Element==false then skip
	    else
	       {self.manager showServiceInfo(Element)}
	    end
	 end
	 meth showServiceInfo(Info)
	    %% HostsFrame, clear
	    {self clear}
	    {self.envBox insertElementsInOrder(Info.vars)} 
	    {self.linuxListBox insertElementsInOrder(Info.linux)} 
	    {self.solarisListBox insertElementsInOrder(Info.solaris)} 
 	    {self.status setMessage(Info.help)}
	 end
	 
	 meth replyToLinuxService(Method Entry)
	    {self.manager replyToMethod('Linux' Method Entry)}
	 end
	 meth replyToSolarisService(Method Entry)
	    {self.manager replyToMethod('Linux' Method Entry)}
	 end
	 meth insertServices(Services)
	    {self.servicesListBox clearElements}
	    {self.servicesListBox insertElements(Services)}      
	 end
	 meth clear
	    {self.envBox clearElements}
	    {self.linuxListBox clearElements}
	    {self.solarisListBox clearElements}
	 end
      end
      class GeneralsFrame
	 from Tk.frame
	 prop locking
	 feat
	    manager
	    generalsListBox
	    envBox
	    linuxListBox
	    solarisListBox
	    popupLinuxGeneral
	    popupSolarisGeneral
            
	 meth init(parent:Parent  manager:Manager symbolDir:SymbolDir status: Status <= proc{$ _} skip end)
	    Tk.frame, tkInit(parent: Parent)
	    
	    
	    GeneralsFrame   = {New Tk.frame tkInit(parent:self
						   relief: groove
						   borderwidth: 1 )}
	    GeneralsListBox = {New TextListBox tkInit(title        : "Settings:"
						      parent       : GeneralsFrame
						      height       : 5
						      width        : 8
						     )}
	    EditButton = {New XTkTools.helpButtonText init(parent : GeneralsFrame
							   status : Status
							   action : self # editEntry
							   text   : 'Edit Settings'
							   help   : 'Edit'
							   message: 'Edit settings for selected service.')}

	    ValueFrame  =  {New Tk.frame tkInit(parent:self
						relief: groove
						   borderwidth: 1 )}
	    EnvBox        = {New TextListBox tkInit(title        : "Variables:"
						    parent       : ValueFrame
						    height       : 5 
						    width        : 18
						   )}
	    LinuxEnvBox   = {New TextListBox tkInit(title        : "Linux Environment:"
						    parent       : ValueFrame
						    height       : 5 
						    width        : 20
						   )}
	    SolarisEnvBox = {New TextListBox tkInit(title        : "Solaris Environment:"
						    parent       : ValueFrame
						    height       : 5
						    width        : 20
						   )}
	 in
	    self.manager             = Manager
	    self.generalsListBox     = GeneralsListBox
	    self.envBox        = EnvBox
	    self.linuxListBox        = LinuxEnvBox
	    self.solarisListBox      = SolarisEnvBox
	    self.popupLinuxGeneral   = {self.linuxListBox   getPopUpMenu(self replyToLinuxGeneral $)}
	    self.popupSolarisGeneral = {self.solarisListBox getPopUpMenu(self replyToSolarisGeneral $)}
	    {Tk.batch [
		       pack(GeneralsListBox GeneralsFrame side:left anchor: w padx:1)
		      ]}
	    
	    {Tk.batch [grid(GeneralsFrame    row: 0 column: 0 sticky:we)
		       grid(ValueFrame       row: 1 column: 0 sticky:nswe)
%		       grid(EnvFrame         row: 1 column: 0 sticky:nswe)
%		       grid(LinuxFrame       row: 1 column: 1 sticky:nswe)
%		       grid(SolarisFrame     row: 1 column: 2 sticky:nswe)
		       
		       grid(GeneralsListBox  row:0 column:0 sticky:w)
		       grid(EnvBox           row:1 column:0 sticky:w)
		       grid(LinuxEnvBox      row:1 column:1 sticky:w)
		       grid(SolarisEnvBox    row:1 column:2 sticky:w)
		       
		       grid(EditButton       row:0 column:3 sticky:w)
		      ]}
	    
	    {self.generalsListBox  tkBind(event : '<1>'
				           action: proc{$}
						      Element = {self.generalsListBox getSelection($)}
						   in
						      {self updateGeneralInfo(Element)}
						   end)}
	    {self.manager showGenerals}
	 end
	 
	 meth updateGeneralInfo(Element)
	    if Element==false then skip
	    else
	       {self.manager showGeneralInfo(Element)}
	    end
	 end
	 meth showGeneralInfo(Info)
	    %% HostsFrame, clear
	    {self clear}
	    {self.envBox insertElementsInOrder(Info.vars)}
	    {self.linuxListBox insertElementsInOrder(Info.linux)}
	    {self.solarisListBox insertElementsInOrder(Info.solaris)}
	 end

	 meth editEntry
	    Element = {self.generalsListBox getSelection($)}
	 in
	    if Element \= false then
	       {self.manager editGeneralInfo(Element)}
	    end
	 end
	 
	 meth replyToLinuxGeneral(Method Entry)
	    {self.manager replyToMethod('Linux' Method Entry)}
	 end
	 meth replyToSolarisGeneral(Method Entry)
	    {self.manager replyToMethod('Linux' Method Entry)}
	 end
	 meth insertGenerals(Generals)
	    {self.generalsListBox clearElements}
	    {self.generalsListBox insertElements(Generals)}      
	 end
	 meth clear
	    {self.envBox clearElements}
	    {self.linuxListBox clearElements}
	    {self.solarisListBox clearElements}
	 end
      end

      class RemoteBrokersFrame
	 from Tk.frame
	 prop locking 
	 feat 
	    manager

	    userEntry
	    methodEntry
	    hostsList
	    urlEntry
	    popupHost
	    popupService

	 meth init(parent:Parent manager:Manager symbolDir:SymbolDir status: Status <= proc{$ _} skip end)
	    
	    Tk.frame, tkInit(parent:Parent relief:raised bd:1)
	    HostsFrame    = {New Tk.frame tkInit(parent:self)}

	    HostsListBox = {New TextListBox tkInit(title        : "Remote Hosts:"
						   parent       : HostsFrame
						   height       : 5
						   width        : 27
						  )}
	    
	    ButtonFrame1  =  {New Tk.frame tkInit(parent: self
						  relief: groove
						  height: 66
						  borderwidth: 1)}
	    EditHostButton = {New XTkTools.helpButtonText         
			      init(parent : ButtonFrame1
				   status : Status
				   action : self # editEntry
				   text   : 'Edit Host'
				   help   : 'Edit Host'
				   message: 'Edit settings for selected host.')}
	    AddHostButton = {New XTkTools.helpButtonText         
			     init(parent : ButtonFrame1
				  status : Status
				  action : self # addEntry
				  text   : 'Add Host'
				  help   : 'Add Host'
				  message: 'Add entry for new host.')}
	    DelHostButton = {New XTkTools.helpButtonText         
			     init(parent : ButtonFrame1
				  status : Status
				  action : self # delEntry
				  text   : 'Del Host'
				  help   : 'Delete Host'
				  message: 'Delete entry for current host.')}
	    
 	    InfoFrame = {New Tk.frame tkInit(parent:self
					     relief: groove
					     height: 55
					     borderwidth: 1)}

	    MethodFrame    = {New Tk.frame tkInit(parent:InfoFrame)}
	    UserFrame     = {New Tk.frame tkInit(parent:InfoFrame)}
	    UrlFrame      = {New Tk.frame tkInit(parent:InfoFrame)}
	    UserLabel       = {New Tk.label tkInit(parent: UserFrame    text:"Login as user:  ")}
	    MethodLabel      = {New Tk.label tkInit(parent: MethodFrame text:"Login Command: ")}
	    UrlLabel        = {New Tk.label tkInit(parent: UrlFrame     text:"WWW-Server: ")}
            
	    UserEntry       = {New Tk.entry tkInit(parent: UserFrame    bg: white width: 10)}
	    MethodEntry      = {New Tk.entry tkInit(parent: MethodFrame bg: white width: 10)}
	    UrlEntry        = {New Tk.entry tkInit(parent: UrlFrame     bg: white width: 20)}
	    
	    {Tk.batch [
		       grid(MethodLabel row: 0  column: 0 sticky: w)
		       grid(MethodEntry row: 0  column: 1 sticky: w)
		      ]}
	    {Tk.batch [
		       grid(UserLabel row: 0 column: 0 sticky:w)
		       grid(UserEntry row: 0 column: 1 sticky:w)
		      ]}
	    {Tk.batch [
		       grid(UrlLabel row: 0 column: 0 sticky:w)
		       grid(UrlEntry row: 0 column: 1 sticky:w)
		      ]}
	 in
	    self.manager      = Manager
	    self.hostsList    = HostsListBox 
	    self.methodEntry   = MethodEntry
	    self.userEntry    = UserEntry
	    self.urlEntry     = UrlEntry

	    {self.hostsList  tkBind(event : '<1>'
				    action: proc{$}
					       Element = {self.hostsList getSelection($)}
					    in
					       RemoteBrokersFrame, updateRemoteBrokerInfo(Element)
					    end)}
	    
	    
	    self.popupHost    =  {self.hostsList getPopUpMenu(self replyToHost $)}
	    
	    {Tk.batch [
		       grid(HostsFrame      row: 0 column: 1 rowspan: 4 sticky:nswe)
		       grid(ButtonFrame1     row: 1 column: 0 sticky: wsne)
		       grid(InfoFrame      row: 1 column: 2 sticky: wsne)
		       grid(HostsListBox    row: 0 column: 1  sticky:nswe)
		       grid(MethodFrame      row: 1 column: 2 sticky: w)
		       grid(UserFrame       row: 0 column: 2 sticky: w)
		       grid(UrlFrame        row: 3 column: 2 sticky: w)
		       
		       grid(AddHostButton   row: 0 column: 0 sticky: w)
		       grid(EditHostButton  row: 1 column: 0 sticky: w)
		       grid(DelHostButton   row: 2 column: 0 sticky: w)
		      ]}
	    {DisablePopUp self 'popupHost'}
	    
	    {self.manager showRemoteBrokers}
	 end

	 
	 
	 meth updateRemoteBrokerInfo(Element)
	    if Element==false then skip
	    else
	       {self.manager showRemoteBrokerInfo(Element)}
	    end
	 end

	 meth replyToHost(Method Entry)
	    {self.manager replyToMethod('Hosts'  Method Entry)}
	 end
	 meth replyToService(Method Entry)
	    {self.manager replyToMethod('Service' Method Entry)}
	 end
	 meth editEntry
	    Host = {self.hostsList getSelection($)}
	 in
	    if Host == false then skip
	    else
	       {self.manager editRemoteHostInfo(Host)}
	    end
	 end
	 meth delEntry
	    Host = {self.hostsList getSelection($)}
	 in
	    if Host == false then skip
	    else
	       {self.manager deleteRemoteHost(Host)}
	    end
	 end
	 meth addEntry
	    {self.manager addRemoteHost}
	 end

	 meth insertRemoteBrokers(Hosts)
	    {self.hostsList clearElements}
	    {self.hostsList insertElementsInOrder(Hosts)}      
	 end
	 
	 meth showRemoteBrokerInfo(Info)
	    /*Info = unit(method:String user: String url:String services: List of Strings)*/
	    %% HostsFrame, clear
	    lock
	       {self clear}
	       {self.methodEntry   tk(insert 0  Info.method)}
	       {self.userEntry    tk(insert 0  Info.login)}
	       {self.urlEntry     tk(insert 0  Info.www)}
	    end
	 end
	 
	 meth clear
	    {self.methodEntry tk(delete 0 'end')}
	    {self.userEntry tk(delete 0 'end')}
	    {self.urlEntry tk(delete 0 'end')}
	 end
      end


      class ConfigsBook
	 from TkTools.notebook
	 feat
	    Notes
	    hostsFrame
	    generalsFrame
	    servicesFrame
	    remoteBrokersFrame
	    
	 meth init(parent:Parent manager:Manager symbolDir: SymbolDir status: Status)
	    
	    TkTools.notebook,tkInit(parent:Parent)
	    %% hosts
	    Hosts = {New TkTools.note tkInit(parent:self
					     text:"Local Hosts")}
	    HostsFr = {New HostsFrame init(parent:Hosts manager:Manager symbolDir: SymbolDir status: Status)}
	    {Tk.send pack(HostsFr)}

	    %% general
	    Generals = {New TkTools.note tkInit(parent:self
						text:"General")}
	    GeneralsFr = {New GeneralsFrame init(parent: Generals manager:Manager symbolDir: SymbolDir status: Status)}
	    {Tk.send pack(GeneralsFr)}
	    
	    %% services
	    Services = {New TkTools.note tkInit(parent:self
						text:"Services")}
	    ServicesFr = {New ServicesFrame init(parent: Services manager:Manager symbolDir: SymbolDir status: Status)}
	    {Tk.send pack(ServicesFr)}
	    
	    %% remote brokers
	    RemoteBrokers = {New TkTools.note tkInit(parent:self
						     text:"Remote Hosts")}
	    RemoteBrokersFr = {New RemoteBrokersFrame init(parent: RemoteBrokers manager:Manager symbolDir: SymbolDir status: Status)}
	    {Tk.send pack(RemoteBrokersFr)}
     
	 in
	    ConfigsBook,add(Generals)
	    ConfigsBook,add(Services)
	    ConfigsBook,add(Hosts) 
	    ConfigsBook,add(RemoteBrokers) 
	    self.hostsFrame         = HostsFr
	    self.generalsFrame      = GeneralsFr
	    self.servicesFrame      = ServicesFr
	    self.remoteBrokersFrame = RemoteBrokersFr
     
	 end
	 meth hostsFrame($)
	    self.hostsFrame
	 end
	 meth servicesFrame($)
	    self.servicesFrame
	 end
	 meth generalsFrame($)
	    self.generalsFrame
	 end
	 meth remoteBrokersFrame($)
	    self.remoteBrokersFrame
	 end
	 
      end %of class
      
   in
      class ToplevelManager
	 feat
	    toplevel 
	 meth init(?PackMe)
	    self.toplevel  = {New Toplevel init(self
						self.menu
						self.symbol
						self.status
						?PackMe
						symbolDir: self.symbolDir)}
	 end
	 %meth clear skip end
	 meth configurePointer(Status) skip end
	 
	 meth close  {self.toplevel tkClose} end

	 meth confirm(Text ?Result)
	    {Wait
	     {New XTkDialog.confirm init(master: self.toplevel
					 aspect: 400
					 title: "Please confirm"
					 text : Text
					 result: ?Result)}.tkClosed}
	 end
	 
	 meth otherwise(...)
	    skip
	 end
      end   
   end

end %define
   
