%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% XService.oz ; This file is part of the MathWeb system
%
%   major updates: 20.12.2000
%
%   Authors: Juergen Zimmer
%
%   email: jzimmer@ags.uni-sb.de
%   
% For information about this program, write to:                          
%   MathWeb-Project                                                        
%   AG Siekmann/FB nformatik                                            
%   Universitaet des Saarlandes                                          
%   Bau 36, 4. Stock                                                     
%   D-66041 Saarbruecken                                                 
%   Germany    
%
% For information about the newest version of MathWeb, see 
%   http://www.mathweb.org/mathweb
%
% See the file "LICENSE" or
%    http://www.mathweb.org/mathweb/LICENSE.html
% for information on usage and redistribution
% of this file, and for a DISCLAIMER OF ALL
% WARRANTIES.
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

functor
import
   Property
   Application

   Manager    at 'x-ozlib://mathweb/config/Manager.ozf'
   
define
   local
      class GUI
	 from BaseObject
	 prop locking final
	    
	 feat
	    symbolDir
	    symbolbarConfig
         attr
	    manager

	 meth Init
	    AddManager = {New Manager.'class' init(self
						   self.symbolDir
						   self.symbolbarConfig
						  )}
         in
            manager <- AddManager
            
         end
         
	 meth init(SymbolDir SymbolbarConfig)
	    lock
	       self.symbolDir       = SymbolDir
	       self.symbolbarConfig = SymbolbarConfig
	    end
	 end
         meth login
	    lock
	       GUI, Init
	    end
	 end
	 meth exit
	    {Application.exit 0}
	 end
      end   
   in
      HOME            = {Property.get 'user.home'}
      SymbolDir       = HOME#'/.oz/mathweb/symbols/'
      SymbolbarConfig = HOME#'/.oz/mathweb/configs/'
      
      Gui = {New GUI init(SymbolDir SymbolbarConfig)}
      {Gui login}
   end
end









