%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% chorus.oz ; This file is part of the MathWeb system
%
%   major updates: 09.08.2001
%
%   Authors: Juergen Zimmer, Andreas Franke
%
%   email: {jzimmer, afranke}@ags.uni-sb.de
%   
% For information about this program, write to:                          
%   MathWeb-Project                                                        
%   AG Siekmann/FB nformatik                                            
%   Universitaet des Saarlandes                                          
%   Bau 36, 4. Stock                                                     
%   D-66041 Saarbruecken                                                 
%   Germany    
%
% For information about the newest version of MathWeb, see 
%   http://www.mathweb.org/mathweb
%
% See the file "LICENSE" or
%    http://www.mathweb.org/mathweb/LICENSE.html
% for information on usage and redistribution
% of this file, and for a DISCLAIMER OF ALL
% WARRANTIES.
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%
%%% CHORUS service
%%%

functor
   
import
   XApplication
   at 'x-ozlib://mathweb/share/XApplication.ozf'

   XService(manager: ServiceManager)
   at 'x-ozlib://mathweb/sys/XService.ozf'
   SimplerServiceClass('class': SimpleService)
   at 'x-ozlib://mathweb/sys/SimpleService.ozf'

   ChorusClient
   at 'http://www.coli.uni-sb.de/cl/projects/chorus/choli2/chorus/mathweb/chorusclient.ozf'
   
define
   AppName     = 'chorus'
   ServiceName = 'CHORUS'
   App         = {New XApplication.manager init}
      
   class ChorusService from SimpleService
      feat
         name: chorus
         
      meth submitProblem(ProblemBS
                         syntax:   Syntax <=chorus
                         result:   ?Out
                         killProc: ?KillP)
         case Syntax of chorus then
            thread
               {ChorusClient.chorusClient ProblemBS ?Out ?KillP}
            end
         else
            raise unknownSyntax(Syntax) end
         end
      end
      
      meth analyzeResult($ result: ChorusOut)
         
%          ProofOk = if {ByteString.length ChorusOut} < 2
%                    then unknown
%                    elseif {ByteString.get ChorusOut 1}==&]
%                    then notsatisfied
%                    else satisfied
%                    end
         State = if {ByteString.length ChorusOut} < 2
                 then undetermined
                 elseif {ByteString.get ChorusOut 1}==&]
                 then unsatisfiable
                 else satisfiable
                 end
         
%          Proof = case ProofOk
%                  of true         then "proof found\n"
%                  [] false        then "-------------------------------\n"
%                  [] satisfied    then "satisfied\n"
%                  [] notsatisfied then "notsatisfied\n"
%                  [] unknown      then "unknown result\n"
%                  end
      in
%          s(string: {ByteString.make Proof}
%            bool  : ProofOk\=true andthen ProofOk\=notsatisfied
%            host  : self.host
%            models: {ByteString.make ChorusOut})
         atp_result(state: State
                    name: self.name
                    host: self.host
                    models: {ByteString.make ChorusOut}
                   )
      end       
   end
   
   ServMan = {New ServiceManager init(ServiceName ChorusService
                                      appName: AppName
                                      appMan:  App)}
   {ServMan offerService}
   {App.exit 0}
end
