%%
%% wrapper for external programs that communicate via stdin/stdout
%%

functor
   
import
   %%Error
   OS

   XApplication
   at 'x-ozlib://mathweb/share/XApplication.ozf'

   XService(threadManager: ThreadManager
	    clientManager: ClientManager
	    faultManager:  FaultManager           
	    manager:       ServiceManager)
   at 'x-ozlib://mathweb/sys/XService.ozf'
      
   Pipe2Socket
   at 'x-ozlib://mathweb/share/Pipe2Socket.ozf'
   
export
   
   
define
   %%VS2S = VirtualString.toString
   
   AppName    = 'isabelle'
   ServerName = 'ISABELLE'
   App        = {New XApplication.manager init}
   %%Host       = {OS.getEnv 'HOST'}

   ISABELLE = {OS.getEnv 'ISABELLE'}
   
   local
      proc {ShowVar Name Val}
         if Val==false
	 then {App.showInfo "$"#Name#" is undefined."} raise abort end
	 else {App.showInfo "$"#Name#" = "#Val}
	 end
      end
   in
      {ShowVar 'ISABELLE' ISABELLE}
   end
   /*
   fun {ErrToVS Exc}
      {Error.messageToVirtualString {Error.exceptionToMessage Exc}}
   end
   */
   %%
   %% main
   %%
   class IsabelleServer from ThreadManager ClientManager FaultManager
                        
      feat
         serverName
         IsabelleKillProc 
         
      meth init(url:    URL      <= false %% ignored
		ticket: Ticket   <= false %% ignored
		cmdArgs: CmdArgs <= unit  %% ignored
	       )
	 self.serverName = ServerName
         ThreadManager, init
      end
      
      meth StartIsabellePipe(ServerArgs exit:?ExitSignal)

         /*
         %% auxiliuary procedures
         proc {SendClient Msg}
            try {Send self.clientPort Msg}
            catch _ then skip end
         end
         proc {SendError VS}
            {SendClient error(VS)}
         end
         proc {DoExit}
            {SendClient exit}
            ExitSignal=unit
         end
         
         %% init method
         Init = local
		   DefaultInit = start(display : self.clientDisplay
				       host    : Host
				       cmds    : CmdsVS
                                       onExit  : DoExit) 
                in
                   if {HasFeature ServerArgs outputLabel} then
                      OutLabel = ServerArgs.outputLabel
                      proc {ShowInfo Line} {SendClient OutLabel(Line)} end
                   in
                      {Adjoin x(showInfo:ShowInfo) DefaultInit}
                   else
                      DefaultInit
                   end
                end
         */
         Cmd  = ISABELLE
         Args = nil
         Host = {CondSelect ServerArgs host "localhost"}
         Port = ServerArgs.port
         KillProc0 Done
      in
         {Pipe2Socket.runClient Cmd Args Host Port ?KillProc0 ?Done}
         self.IsabelleKillProc = KillProc0
         ExitSignal            = Done
      end

      /** This method enters an Isabelle service */
      /** NOTE: ClientInfo = ClientName(name: user: host: display: port:) */
      /**       ServerArgs = unit(mode: remoteURL: sessionID:) */
      meth enter(client: ClientInfo <= unit
		 args:   ServerArgs <= unit)
	 
	 ClientManager, init(ClientInfo)
         ClientManager, showEnter(self.appManager.showInfo)
         ClientManager, startThreads
         /*
         ExitSignal
      in
	 IsabelleServer, StartIsabellePipe(ServerArgs exit:?ExitSignal)

         {Delay 2500} % important !!!
	 
	 if {IsFree ExitSignal} then
            IsabelleServer, StartReader
	    IsabelleServer, StartServObj
            IsabelleServer, InstallWatcher    
	 end
         */
      end

      meth connect(host:H<="localhost" port:P $<=_)
         IsabelleServer, StartIsabellePipe(unit(host:H port:P) exit:_)
         "Isabelle server started."
      end
      
      /*
      meth InstallWatcher
	 proc {Watch _ _}
	    {self.appManager.showInfo
	     "*** "#self.clientName#" died. Exiting..."}
	    if {HasFeature self serverProc}
            then {self.serverProc leave}
	    else {self leave}
	    end
         end
      in
	 FaultManager, installWatcher(Watch)
      end
      */
      /*
      %%
      %% socket communication between LISP and LOUI
      %%
      meth StartReader
         proc {Reader}
            Msg = {self.inout getS($)} in
            {self.appManager.showInfo "[ReadSocket]: "#Msg}
            {Send self.clientPort msg({ByteString.make Msg})}
            {Reader}
         end
         proc {DoThread}
            try {Reader}
            catch Err then
               case Err of system(kernel(terminate...)) then
                  try {Send self.clientPort false}
                  catch system(dp(...)...) then skip end
               [] connectionClosed then
                  Msg = "Socket connection closed by LISP process." in
                  try {Send self.clientPort error(Msg)}
                  catch system(dp(...)...) then skip end
               else
                  Msg = "Error while reading from socket:\n"#{ErrToVS Err} in
                  try {Send self.clientPort error(Msg)}
                  catch system(dp(...)...) then skip end
               end
            end
         end
      in
         ThreadManager, newThread(DoThread info:'socket-reader')
      end

      meth send(String)
         {self.appManager.showInfo "[WritePipe]: "#String}
         {self.inout putS(String)}
      end

      meth sig(Signal $<=_)
	 {Process.sigF Signal self.IsabellePipe.pid}
      end
      */
      
      meth leave
	 {self.appManager.printInfo "Service "#ServerName#" is left...\n"}
         %%FaultManager, deinstallWatcher
         ThreadManager, tryTerminateAll
         /*
         if {IsDet self.ServObj} then
            {self.ServObj shutdown}
         end
         */
         {self.IsabelleKillProc} %%{self.IsabellePipe close}
         %%{ForAll [inout serv] proc {$ Sock} {self.Sock close} end}
         {self.appManager.showInfo " done."}
         {Thread.terminate {Thread.this}}
      end
      
   end % of IsabelleServer
   
   ServMan = {New ServiceManager init(ServerName IsabelleServer
				      appName: AppName
				      appMan:  App
				      %%argSpec: ArgSpec 
				      )}
   {ServMan offerService}
end
