%%
%% MBASE test program
%%

functor

import
   Application(getCmdArgs exit)
   OS(getEnv localTime)
   System
   
   
   OmdocDB('class': Mbase)
   at 'x-ozlib://mathweb/mbase/OmdocDB.ozf'

   Benchmark(getTime: GetTime)
   at 'x-ozlib://mathweb/share/Benchmark.ozf'
   
   Browser(browse:Browse)
define
   AppName = 'mtest'

   HOME = {OS.getEnv "HOME"}

   %% auxiliuary functions
   VS2S = VirtualString.toString
   %%VS2BS = ByteString.make
   %%V2VS = fun {$ X} {Value.toVirtualString X 1000 1000} end
   
   DefaultDir       = {VS2S HOME#"/import/mathweb/mbase/www/dev/"}
   DefaultStartFile = {VS2S DefaultDir#"index.html"}

   DefaultHost = "mbase.mathweb.org" % or: "localhost"

   Spec = record(port(single char:&p type:int default:8080)
                 startpage(single type:string default:DefaultStartFile)
                 resolver(single char:&r type:string default:false)
                 default(single type:string default:DefaultDir)
                 dbhost(single char:&h type:string default:DefaultHost)
                 dbuser(single char:&u type:string default:"mbase")
                 dbpass(single type:string default:"")
                 dbname(single type:string default:"mbase")
                )
   Args
   try
      Args = {Application.getCmdArgs Spec}
   catch error(ap(usage S)...) then
      {System.showError AppName#": "#S}
      {Application.exit 1}
   end

   DB = {New Mbase noop}

   {DB connectToDatabase(host: Args.dbhost
			 user: Args.dbuser
			 password: Args.dbpass
			 dbname: Args.dbname
			)}
   {Browse {OS.localTime}}
   {Browse {DB getAxioms(name: "sin" $)}}
   {Browse {Time.time}}
%   {Application.exit 0}
end





