%%
%%  a test program for kimba
%%

functor
   
import
   XApplication
   at 'x-ozlib://mathweb/share/XApplication.ozf'
   
   Browser(browse: Browse)
   
   BrokerAccess(getBroker)
   at 'x-ozlib://mathweb/sys/BrokerAccess.ozf'
   
define
   App     = {New XApplication.manager init}
   AppName = "testkimba"
   %% The command line arguments
   DefaultTicket = "http://www.mathweb.org/~jzimmer/broker@goedel"
   Spec = record(brokerticket(single type:string default: DefaultTicket))

Args
   try
      Args = {App.getCmdArgs Spec}
   catch error(ap(usage S)...) then
      {App.showError AppName#': '#S}
      {App.exit 1}
   end
   %% end of args
   
   Broker = {BrokerAccess.getBroker App Args}.send
   
   Kimba = {Broker request("KIMBA" $)}
   
   Problem = "p(remark: 'Reading: r(1,cons,1) '
  types: are(o:o i:i)
  logic: classical
  engine: 'first-order'
  population: 12 
  constants: are(
                 'walk': [o i i]
                 'present': [o i]
                 'event': [o i]
                 'unisex': [o i]
                 'eventuality': [o i]
                 'male': [o i]
                 'man': [o i]
                 'human_person': [o i]
                 'organism': [o i]
                 'single': [o i]
                 'entity': [o i]
                )
  formulas: [
             'forall'('A'#i ['implies' ['entity' 'A'] ['single' 'A']])
             'forall'('A'#i ['implies' ['organism' 'A'] ['entity' 'A']])
             'forall'('A'#i ['implies' ['human_person' 'A'] ['organism' 'A']])
             'forall'('A'#i ['implies' ['man' 'A'] ['human_person' 'A']])
             'forall'('A'#i ['implies' ['man' 'A'] ['male' 'A']])
             'forall'('A'#i ['implies' ['eventuality' 'A'] ['single' 'A']])
             'forall'('A'#i ['implies' ['eventuality' 'A'] ['unisex' 'A']])
             'forall'('A'#i ['implies' ['event' 'A'] ['eventuality' 'A']])
             'forall'('A'#i ['implies' ['eventuality' 'A'] ['not' ['entity' 'A']]])
             'forall'('A'#i ['implies' ['unisex' 'A'] ['not' ['male' 'A']]])
             'exists'('A'#i 'exists'('B'#i ['and' ['man' 'A'] ['and' ['event' 'B'] ['and' ['present' 'B'] ['walk' 'B' 'A']]]]))
            ])"

%       meth prove(ProblemBS ?Result
% 		 syntax: Syntax <= unit
% 		 times:  ?Times <= _
% 		)
   VS2BS = VirtualString.toByteString

   Result 
   {Kimba enter}
   {Kimba prove({VS2BS Problem} ?Result
                replyWith: result(state: unit
                                  name: unit
                                  host: unit
                                  times: unit
                                  output: unit)
               )}
   {Wait Result}
   {Browse Result}
%% Result is a record
%%     s(string: Proof      % the proof!
%%       bool:   Failed?    % boolean indicating if the prover is failed 
%%       host:   self.host) % name of the host the prover runs on

   {Kimba leave}

%   {App.exit 0}
end


