

%{
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#define YYSTYPE char*
char buffer[64000];
char myinput[64000];
char *myinputptr;
int myinputlength;
%}




%token TID NUMBER '(' ')'  ';' ABS ',' '='
%left '+' '-'
%left '*' '/' 
%nonassoc '^' MOD

%%

input: expr { printf("%s\n", $1); return 0; }
;

 
expr: TID       { $$ = strdup($1); }
| ABS '(' expr ')'  { sprintf(buffer, "(absval  %s)",  $3); 
                  $$ = strdup(buffer); }
| expr '=' expr { sprintf(buffer, "(= %s %s)", $1, $3); 
                  $$ = strdup(buffer); }
| expr '+' expr { sprintf(buffer, "(plus %s %s)", $1, $3); 
                  $$ = strdup(buffer); }
| expr '-' expr { sprintf(buffer, "(minus %s %s)", $1, $3); 
                  $$ = strdup(buffer); }
| expr '*' expr { sprintf(buffer, "(times %s %s)", $1, $3); 
                  $$ = strdup(buffer); }
| expr '/' expr { sprintf(buffer, "(div %s %s)", $1, $3); 
                  $$ = strdup(buffer); }
| expr MOD expr { sprintf(buffer, "(mod %s %s)", $1, $3); 
                  $$ = strdup(buffer); }
| expr '^' expr { sprintf(buffer, "(power %s %s)", $1, $3); 
                  $$ = strdup(buffer); }
| '-' NUMBER    { sprintf(buffer, "-%s", $2); 
                  $$ = strdup(buffer); }
| NUMBER        { sprintf(buffer, "%s", $1); 
                  $$ = strdup(buffer); }
| '-' expr      { sprintf(buffer, "(minus 0 %s)", $2); 
                  $$ = strdup(buffer); }
| expr '(' expr ')'      { sprintf(buffer, "(%s %s)", $1, $3); 
                  $$ = strdup(buffer); }
| expr '(' expr ',' expr ')'      { sprintf(buffer, "(%s %s %s)", $1, $3, $5); 
                  $$ = strdup(buffer); }
| expr '(' expr ',' expr ',' expr ')'      { sprintf(buffer, "(%s %s %s %s)", $1, $3, $5, $7); 
                  $$ = strdup(buffer); }
| expr '(' expr ',' expr ',' expr ',' expr ')'      { sprintf(buffer, "(%s %s %s %s %s)", $1, $3, $5, $7, $9); 
                  $$ = strdup(buffer); }
| '(' expr ')' { $$ = $2; }
;

%%

void divdiv2divmult ()

     /* Beware! Very bad code ahead.                                 */ 
     /* Somebody who knows more about C should do this better.       */
     /* This procedure transforms Maple-ouput like a/b/c to a/(b*c), */
     /* and stores it in myinput[].                                  */
     /* It should handle leading terms like 1/2 * a/b correctly.     */
     /* The result is given to the parser.                           */
     /* Added the handling of quotations: "..." -> ...;.             */
     /* Added the transformations for leading '-'.                   */
     /* Added the handling of abs(-..).                              */
     
{
  char posterm[10000];
  char negterm[10000];
  char restterm[10000];
  char frontterm[10000];

  int endneg=0;   
  int endpos=0;   

  int end=0;
  int enddiv=0;
  char inchar;   
  int counter=0;
  int bracket=0;
  int countquote=0;

  /* Transformation a/b/c --> a/(b*c) */  
  
  do
    {   
      scanf("%c", &inchar);            //scan chars from stdin              
      switch(inchar)
	{
	case '/':                      //go into '/'-modus  
	  enddiv=0;
	  myinput[counter]=inchar;
	  counter++;
	  myinput[counter]='(';
	  counter++;
	  do
	    {
	      scanf("%c", &inchar);         //read the next items from here
	      switch(inchar)
		{
		case '/':                   //transform /a/.. to /(a*..
		  myinput[counter]='*';
		  counter++; 
		  break;
		case '(':                   //don't touch things in brackets, just copy
		  myinput[counter]=inchar;
		  counter++;
		  bracket=1;
		  do{
		    scanf("%c", &inchar);
		    myinput[counter]=inchar;
		    counter++;
		    if (inchar==')') bracket--;
		    else if (inchar=='(') bracket++;
		  }
		  while(bracket!=0);
		  break;
		case '-':                   //aha, get out of the the '/'-modus
		  myinput[counter]=')';
		  counter++;
		  myinput[counter]=inchar;
		  counter++;
		  enddiv=1;
		  break;
		case '+':                   //same
		  myinput[counter]=')';
		  counter++;
		  myinput[counter]=inchar;
		  counter++;
		  enddiv=1;
		  break;
		case '*':                   //same
		  myinput[counter]=')';
		  counter++;
		  myinput[counter]=inchar;
		  counter++;
		  enddiv=1;
		  break;
		case '"':                   //the end, close everthing and go out of here
		  myinput[counter]=')';
		  counter++;
		  myinput[counter]=';';
		  counter++;
		  end=1;
		  enddiv=1;
		  break;
		case ';':                   //the end, close everthing and go out of here
		  myinput[counter]=')';
		  counter++;
		  myinput[counter]=inchar;
		  counter++;
		  end=1;
		  enddiv=1;
		  break;
		default:                    //just copy everything else
		  myinput[counter]=inchar;
		  counter++;
		  break;
		}
	    }
	  while(enddiv==0);  
	  break;
	case '"':                     // ignore the first '"', replace the second '"' with ';' and exit 
	  if (countquote==0) countquote++;
	  else 
	    {	  
	          myinput[counter]=';';
		  counter++;
		  end=1;
	    }
	  break;                       
	case ';':                    //bye
	  myinput[counter]=inchar;
	  counter++;
	  end=1;
	  break;
	default:                     //everything else
	  myinput[counter]=inchar;
	  counter++;
	  break;
	    }
	}
  while(end==0);
  
  myinputlength=counter;                           //var for lex
  myinputptr=malloc(myinputlength*10);   

  /* Transformation -(term) --> (-term') */  

  end=0;
  enddiv=0;
  counter=0;
  bracket=0;
  endneg=0;   
  endpos=0;   

  if ((myinput[0]=='-') && (myinput[1]=='('))       //leading -(...
    { 	  
  myinput[0]='(';

      if (myinput[2]=='-')
	{
	  myinput[1]=' ';
	  myinput[2]=' ';
	  counter=3;
	}
      else
	{
	  myinput[1]='-';
	  counter=2;
	}

      // printf("Before -(:: %s\n",myinput);
     
     do
	{
	  switch(myinput[counter])
	    {
	    case '(':                   //don't touch things in brackets, just copy
	      counter++;
	      bracket=1;
	      do{
		if (myinput[counter]==')') bracket--;
		else if (myinput[counter]=='(') bracket++;
		counter++;
	      }
	      while(bracket!=0);
	      break;
	    case '+':                      
	      myinput[counter]='-';    // change + to -
	      counter++;
	      break;
	    case '-':                      
	      myinput[counter]='+';    // and - to +
	      counter++;
	      break;
	    case ';':        //the end: exit                    
	      end=1;
	      break;
	    case ')':        //we are now at the closing bracket of '-(...': exit              
	      end=1;
	      break;
	    default:                     //everything else: do nothing
	      counter++;
	      break;
	    }
	}
      while(end==0);
    }    

  //printf("After -(:: %s\n",myinput);
  
  /* Transformation (-term)     --> (term`)     */  
  /* Transformation  -term      -->  term`      */  
  /* Transformation abs(-term)  --> abs(term`)  */  

  end=0;
  enddiv=0;
  counter=0;
  bracket=0;
  endneg=0;   
  endpos=0;   

  if ((myinput[0]=='-') ||
      ((myinput[0]=='(') && (myinput[1]=='-')) ||
      (strncmp(myinput, "abs(-", 5)==0))                      //leading - or (-
    {
  if (myinput[0]=='-')
      {
	negterm[0]=myinput[0];
	counter=1;
      }
      else 
	{
	  if (myinput[1]=='-')
	    {
	      frontterm[0]='(';
	      negterm[0]=' ';
	      negterm[1]='-';
	      counter=2;
	    }
	  else
	    {
	      strcpy(frontterm, "abs(");
	      strcpy(negterm,   "    -");
	      counter=5;
	    }
	}

      do
	{
	  switch(myinput[counter])
	    {
	    case '(':                   //don't touch things in brackets, just copy
	      negterm[counter]=myinput[counter];
	      counter++;
	      bracket=1;
	      do{
		negterm[counter]=myinput[counter];
		if (myinput[counter]==')') bracket--;
		else if (myinput[counter]=='(') bracket++;
		counter++;
	      }
	      while(bracket!=0);
	      break;
	    case '+':                      //go into '+'-modus  
	      //posterm[counter-endneg]=myinput[counter];
	      counter++;
	      endneg=counter;
	      do
		{
		  switch(myinput[counter])                //read the next items from here
		    {
		    case '(':                          //don't touch things in brackets, just copy
		      posterm[counter-endneg]=myinput[counter];
		      counter++;
		      bracket=1;
		      do{
			posterm[counter-endneg]=myinput[counter];
			if (myinput[counter]==')') bracket--;
			else if (myinput[counter]=='(') bracket++;
			counter++;
		      }
		      while(bracket!=0);
		      break;
		    case ';':                   //store the end in restterm and exit
		      endpos=counter;
		      restterm[counter-endpos]=myinput[counter];
		      counter++;
		      enddiv=1;
		      end=1;
		      break;
		    case ')':                   //same for the ending bracket
		      endpos=counter;
		      do
			{
			  restterm[counter-endpos]=myinput[counter];
			  counter++;
			}
		      while(myinput[counter]!=';');
		      enddiv=1;
		      end=1;
		      break;
		    default:                    //just copy everything else
		      posterm[counter-endneg]=myinput[counter];
		      counter++;
		      break;
		    }
		}
	      while(enddiv==0);  
	      break;
	    case ';':                    //bye
	      endpos=counter;
	      restterm[counter-endpos]=myinput[counter];
	      counter++;
	      end=1;
	      break;
	    case ')':                   //same for the ending bracket
	      endpos=counter;
	      do
		{
		  restterm[counter-endpos]=myinput[counter];
		  counter++;
		}
	      while(myinput[counter]!=';');
	      end=1;
	      break;
	    default:                     //everything else
	      negterm[counter]=myinput[counter];
	      counter++;
	      break;
	    }
	}
      while(end==0);

      strcpy(myinputptr, strcat (frontterm,
				 strcat(posterm, 
					strcat(negterm, restterm))));  //pointer to the formula for lex
      // printf("End: front %s neg %s pos %s rest %s ALL %S \n",
      //     frontterm ,posterm, negterm, restterm, myinputptr);
    }
  else
    {
      strcpy(myinputptr, myinput);
    }
}


int main (int argc, char *argv[])
{
  int i;
  short pr=0;

  for (i=0; i<argc; i++) {
    if (strcmp(argv[i],"-f") == 0) {
	  pr = 1;
    }
  }
  
  
  if (pr == 1) 
    {
      divdiv2divmult();
      yyparse ();
      return 0;
    }
  else 
    {
      i=0;
      while (1) 
	{
	  printf(">");
	  divdiv2divmult();
   	  //	  printf("Trace: \n%s\n%s\n",  myinput, myinputptr);
	  yyparse ();
	}
  }
}


#include <stdio.h>
     
yyerror (s)  /* Called by yyparse on error */
     char *s;
{
  printf ("Error: %s\n", s);
}

