

%{
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#define YYSTYPE char*
char buffer[64000];
%}




%token TID '(' ')' '-' ';' ABSVAL PLUS MINUS TIMES DIV POWER EQUAL MOD

%%

input: expr { printf("%s\n", $1); return 0; }
;

expr: TID { $$ = strdup($1); }
| '(' ABSVAL  expr ')'        { sprintf(buffer, "abs ( %s )",  $3); 
                  $$ = strdup(buffer); }
| '(' EQUAL expr expr ')'   { sprintf(buffer, "%s = %s", $3, $4); 
                  $$ = strdup(buffer); }
| '(' PLUS expr expr ')'   { sprintf(buffer, "(%s + %s)", $3, $4); 
                  $$ = strdup(buffer); }
| '(' MINUS expr expr ')'  { sprintf(buffer, "(%s - %s)", $3, $4); 
                  $$ = strdup(buffer); }
| '(' TIMES expr expr ')' { sprintf(buffer, "(%s * %s)", $3, $4); 
                  $$ = strdup(buffer); }
| '(' DIV expr expr ')'    { sprintf(buffer, "(%s / %s)", $3, $4); 
                  $$ = strdup(buffer); }
| '(' MOD expr expr ')'   { sprintf(buffer, "(%s mod %s)", $3, $4); 
                  $$ = strdup(buffer); }
| '(' POWER expr expr ')'  { sprintf(buffer, "(%s ^ %s)", $3, $4); 
                  $$ = strdup(buffer); }
| '-' expr                 { sprintf(buffer, "(- %s)", $2); 
                  $$ = strdup(buffer); }
| '{' expr '}'             { sprintf(buffer, "{ %s }", $2 ); 
                  $$ = strdup(buffer); }
| expr ',' expr            { sprintf(buffer, "%s , %s ", $1, $3 ); 
                  $$ = strdup(buffer); }
| '(' expr ')'             { sprintf(buffer, "( %s )", $2 ); 
                  $$ = strdup(buffer); }
| '(' expr expr ')'        { sprintf(buffer, " %s(%s) ", $2, $3); 
                  $$ = strdup(buffer); }
| '(' expr expr expr ')'        { sprintf(buffer, " %s(%s,%s) ", $2, $3, $4 ); 
                  $$ = strdup(buffer); }
| '(' expr expr expr expr ')'        { sprintf(buffer, " %s(%s,%s,%s) ", $2, $3, $4, $5 ); 
                  $$ = strdup(buffer); }
| '(' expr expr expr expr expr ')'        { sprintf(buffer, " %s(%s,%s,%s,%s) ", $2, $3, $4, $5, $6 ); 
                  $$ = strdup(buffer); }
;

%%

int main (int argc, char *argv[])
{
  int i;
  short pr=0;

  for (i=0; i<argc; i++) {
    if (strcmp(argv[i],"-f") == 0) {
	  pr = 1;
    }
  }

  if (pr == 1) {
    yyparse ();
    return 0;
  }
  else {
    while (1) {
      printf(">");
      yyparse ();
    }
  }
}


#include <stdio.h>
     
yyerror (s)  /* Called by yyparse on error */
     char *s;
{
  printf ("Error: %s\n", s);
}


