%%% -*- indent-tabs-mode: nil -*-
%%%
%%% Author:
%%%   Andreas Franke <afranke@mathweb.org>
%%%   Juergen Zimmer <jzimmer@mathweb.org>
%%%
%%% Copyright:
%%%   Andreas Franke 2000-2001
%%%
%%% Last change:
%%%   $Date: 2001/07/20 18:33:21 $ by $Author: afranke $
%%%   $Revision: 1.2 $
%%%
%%% This file is part of MathWeb
%%%    http://www.mathweb.org/mathweb
%%%
%%% See the file "LICENSE" or
%%%    http://www.mathweb.org/mathweb/LICENSE.html
%%% for information on usage and redistribution
%%% of this file, and for a DISCLAIMER OF ALL
%%% WARRANTIES.
%%%

/**
% utility function for broker access
*/

functor

import
   Connection(take)
   Pickle(load)
   
   XURL(loadVS)
   at 'x-ozlib://mathweb/share/XURL.ozf'

   File(type)
   at 'x-ozlib://mathweb/share/File.ozf'

export
   defaultURL: DefaultBroker
   getBroker:  GetBroker
   
define

   VS2A = VirtualString.toAtom
   
   DefaultBroker  = "http://www.mathweb.org/~mathweb/broker"
   %%OmegadevBroker = "http://www.ags.uni-sb.de/~omegadev/broker-ticket.ozc"

   fun {GetTicketFromURL BrokerURL}
      if {File.type BrokerURL}==dir
      then {Pickle.load BrokerURL#"/broker-ticket.ozc"}
      else {VS2A {XURL.loadVS BrokerURL}}
      end
   end
   
   fun {GetBroker App Args}
      BrokerURL
      BrokerTicket
      Broker
   in
      case {App.getEnv 'BROKER_TICKET'}
      of false then
	 if {HasFeature Args brokerticket} then
	    BrokerURL = Args.brokerticket
	    {App.printInfo "Loading broker-ticket from `"#BrokerURL#"'..."}
	    BrokerTicket = {GetTicketFromURL BrokerURL}
	    {App.showInfo " done."}
	 else
	    {App.show no_broker_ticket_set}
	    BrokerURL = DefaultBroker
	    {App.printInfo "Loading broker-ticket from `"#BrokerURL#"'..."}
	    BrokerTicket = {GetTicketFromURL BrokerURL}%{Pickle.load BrokerURL}
	    {App.showInfo " done."}
	 end
      [] BROKER_TICKET then
	 {App.show broker_ticket(BROKER_TICKET)}
	 BrokerURL    = false
	 BrokerTicket = {VirtualString.toAtom BROKER_TICKET}
      end
      {App.printInfo "Connecting to broker at "#BrokerTicket#"..."}
      Broker = {Connection.take BrokerTicket}
      {App.showInfo " done."}
      %%
      broker(url:    BrokerURL
	     ticket: BrokerTicket
	     send:   Broker)
   end
end

