%%% -*- indent-tabs-mode: nil -*-

%%
%% register an xmlrpc handler for the creation of iloui applets
%%

functor
   
import   
   Connection(take)
   Error(exceptionToMessage messageToVirtualString)
   Pickle(load)
   
   XApplication at 'x-ozlib://mathweb/share/XApplication.ozf'
   XURL         at 'x-ozlib://mathweb/share/XURL.ozf'
   File         at 'x-ozlib://mathweb/share/File.ozf'
   
define
   
   VS2A = VirtualString.toAtom
   
   AppName = 'pingpong'
   App     = {New XApplication.manager init}

   Broker1 = "http://www.mathweb.org/~mathweb/broker@leibniz"
   
   Spec = record(brokerticket(single char:[&t &b] type:string default:Broker1))
   Args
   try
      Args = {App.getCmdArgs Spec}
   catch error(ap(usage S)...) then
      {App.showError AppName#": "#S}
      {App.exit 1}
   end
   
   %% =====================
   %% Connect to the broker
   %% =====================
   local BrokerTicket BrokerURL
   in
      case {App.getEnv 'BROKER_TICKET'}
      of false then
         if {HasFeature Args brokerticket} then
            BrokerURL = Args.brokerticket
            {App.printInfo "Loading broker-ticket from `"#BrokerURL#"'..."}
            BrokerTicket = if {File.type BrokerURL}==dir
                           then {Pickle.load BrokerURL#"/broker-ticket.ozc"}
                           else {VS2A {XURL.loadVS BrokerURL}}
                           end
            {App.showInfo " done."}
         else
            {App.show no_broker_ticket_set}
            BrokerURL = "http://www.ags.uni-sb.de/~omegadev/broker-ticket.ozc"
            {App.printInfo "Loading broker-ticket from `"#BrokerURL#"'..."}
            BrokerTicket = {Pickle.load BrokerURL}
            {App.showInfo " done."}
         end
      [] BROKER_TICKET then
         {App.show broker_ticket(BROKER_TICKET)}
         BrokerURL    = false
         BrokerTicket = {VirtualString.toAtom BROKER_TICKET}
      end
      {App.printInfo "Connecting to broker at "#BrokerTicket#"..."}
      Broker = {Connection.take BrokerTicket}
      {App.showInfo " done."}
   end
   
   class PingPongService from BaseObject
                            
      meth ping($)
         pong
      end
   end

   PingPong = {App newServer(PingPongService noop $
                             detach: true
                             info:   "pingpong")}
   
   case {Broker request('XMLRPC_SERVER' $)}
   of false then
      {App.showError "*** No XMLRPC_SERVER available!"}
      {App.exit 1}
   [] XMLRPC_SERVER then
      {XMLRPC_SERVER addHandler("/objectBroker" PingPong mode:tuple)}
      {App.exit 0}
   end
   
end

