%%% -*- indent-tabs-mode: nil -*-

%%
%% xmlrpcd will be a generic xml-rpc server
%%

functor
   
import   
   %%
   %% from broker.oz
   %%
   /*
   OS(unlink getEnv)
   Connection
   DPMisc(initIPConnection)
 
   XApplication    at 'x-ozlib://mathweb/share/XApplication.ozf'
   XURL            at 'x-ozlib://mathweb/share/XURL.ozf'
   Internet        at 'x-ozlib://mathweb/share/Internet.ozf'
   ServiceRegistry at 'x-ozlib://mathweb/sys/ServiceRegistry.ozf'
   Env(home:Home)  at 'x-ozlib://mathweb/share/Env.ozf'
   File            at 'x-ozlib://mathweb/share/File.ozf'
   */

   %%
   %% from old xmlrpcd.oz
   %%
   Connection(take)
   Error(exceptionToMessage messageToVirtualString)
   OS(getPID signal)
   Pickle(load save)
   %%Property(put)
   Browser
   
   XApplication at 'x-ozlib://mathweb/share/XApplication.ozf'
   XURL         at 'x-ozlib://mathweb/share/XURL.ozf'
   File         at 'x-ozlib://mathweb/share/File.ozf'
   Internet     at 'x-ozlib://mathweb/share/Internet.ozf'
   
   XmlRpcServer(server:     RpcServer
                connection: RpcConnection)
   at 'x-ozlib://mathweb/xmlrpc/XmlRpcServer.ozf'
   
   DummyHandler(call)
   at 'x-ozlib://mathweb/xmlrpc/DummyHandler.ozf'
      
define
   
   /*
   AppName = 'broker'
   DefaultTicketName = 'broker-ticket'
   
   MyTicketFile     %% the local broker-ticket
                    % e.g. /home/mathweb/public_html/broker@leibniz
   MyTicketURL      %% the URL to the broker-ticket
                    % e.g. http://www.ags.uni-sb.de/~mathweb/broker@leibniz
   
   App = {New XApplication.manager init}
   
   %% The command line arguments
   Spec = record(ticketfile(single char:[&t &d]  type:string)
                 portticketurl( single           type:string)
                 ticketurl(     single char:[&u] type:string  default: unit))
   Args
   try
      Args = {App.getCmdArgs Spec}
   catch error(ap(usage S)...) then
      {App.showError AppName#': '#S}
      {App.exit 1}
   end
   %% end of args

   VS2A = VirtualString.toAtom
   Port = {DPMisc.initIPConnection info}.port

   PortTicketURL = if {HasFeature Args portticketurl} then
                      Args.portticketurl
                   else
                      {OS.getEnv "PORT_TICKET_URL"}
                   end

   if PortTicketURL \= false then
      {App.showInfo "portticket: "#PortTicketURL}
   end

   Host = Internet.hostname
   
   local
      proc {MkObject Entry ?Object ?Done}
         case Entry.mode
         of create then  %% 
            MetaService = Entry.1 in
            try
               %%{App.print(nfo 'Creating ServiceObject...'}
               SObject = {MetaService create($)}  %% gives a port-send proc
               %% ToDo: should give a port to enable installation of watchers
            in
               {WaitOr SObject {Alarm 50000}}
               if {IsDet SObject} then
                  %%{App.showInfo ' done.'}
                  Object = SObject
                  Done   = unit
               else
                  %%{App.showInfo ' failed.'}
                  Object = false
                  Done   = timeout(create)
               end
            catch Err then
               Object = false
               Done   = Err
            end
         [] port then
            P SObject in
            P = Entry.1
            proc {SObject M} {Port.send P M} end
            try
               Ping = {SObject ping($)}
            in
               {WaitOr Ping {Alarm 50000}}
               if {IsDet Ping} then
                  %%{App.showInfo ' alive.'}
                  Object = SObject
                  Done   = unit
               else
                  %%{App.showInfo ' no answer.'}
                  Object = false
                  Done   = timeout(ping)
               end
            catch Err then
               Object = false
               Done   = Err
            end
         end
      end
      
   in
      
      class Broker

         feat
            Services % a registry with the local services
	    
         meth init()
            self.Services = {New ServiceRegistry.'class' init(App)}
         end
	 
         meth showLocalServices
            {App.showInfo 'Local services:'}
            {ForAll {self.Services names($)}
             proc{$ S}
                {App.showInfo '  '#S}
             end}
         end

         meth offer(ServiceName Service ?ServiceID
                    mode:      Mode       <= create
                    host:      Host       <= "<unknown>"
                    signature: Signature  <= unit
                    done:      Done       <= _
                    kqmlagent: Agent      <= false
                   )
            try
               Entry = entry(Service
                             name:      ServiceName
                             mode:      Mode
                             host:      Host
                             signature: Signature)
            in
               {self.Services register(ServiceName Entry ?ServiceID)}
               {App.showInfo ' done.'}	
               Done = unit
            catch Err then
               {App printExc(Err)}
               Done = Err
            end
         end

         meth retire(ServiceID
                     signature: Signature <= unit
                     done:      Done      <= _)
            try
               Entry             = {self.Services getID(ServiceID $)}
               ServiceName       = Entry.name
               OriginalSignature = Entry.signature
            in
               {App.printInfo 'Service \''#ServiceName#'\' is retired...'}
               if Signature == OriginalSignature
               then
                  {self.Services unregister(ServiceName ServiceID)}
                  {App.showInfo ' done.'}
                  Done = unit
               else
                  {App.showInfo ' Signature mismatch!'}
                  Done = signature(mismatch)
               end
            catch Err then
               {App printExc(Err)}
               Done = Err
            end
         end
	 
         meth services(?Servs)
            Servs = {self.Services names($)}
         end
	 
         meth request(ServiceName ?Object
                      client:  ClientName <= anonymous
                      timeOut: TimeOut    <= 0
                      done:    Done       <= _) = M
            try
               ServiceIDs = {self.Services getIDsByName({VS2A ServiceName} $)}
            in
               {App.printInfo 'Service \''#ServiceName#'\' is requested...'}
               case ServiceIDs
               of nil then {App.showInfo ' not found locally...'}
               [] FirstID|_ then
                  {App.showInfo ' found.'}
                  {MkObject {self.Services getID(FirstID $)} ?Object ?Done}
               end
            catch Err then
               {App printExc(Err)}
               Done = Err
            end
         end
         
         meth available(ServiceName $
                        ping: Ping <= true)=M
            try
               ServiceIDs = {self.Services getIDsByName({VS2A ServiceName} $)}
               fun {ServiceOk ID}
                  Entry = {self.Services getID(ID $)}
               in
                  case Entry.mode
                  of create then
                     MetaService = Entry.1
                     Signal = try {MetaService ping($)}
                              catch _ then error end
                  in
                     {WaitOr Signal {Alarm 50000}}
                     {IsDet Signal} andthen Signal\=error
                  end
               end   
            in
               if ServiceIDs\=nil andthen
                  (Ping==false orelse
                   {Filter ServiceIDs ServiceOk} \= nil) then
                  true
               else
                  true
               end
            catch Err then
               {App printExc(Err)}
               false
            end
         end
	 
      end %% end of class Broker
   end  
   
   %%==================================================
   %% create new broker server and handle ticket
   %%--------------------------------------------------
   try
      {App.showInfo 'Looking for an existing broker-ticket:'}
      TicketFile OldTicket BrokerProc  Signal
   in
      if {HasFeature Args ticketfile} then
         MyTicketFile = Args.ticketfile
         {App.showInfo MyTicketFile}
         {App.printInfo 'Loading \`'#MyTicketFile#'\`...'}
         OldTicket = {VS2A {XURL.loadVS MyTicketFile}}
         {App.showInfo ' done.'}
      else
         case {App getEnv('BROKER_TICKET' $)} of false then
            TicketFile = Home#"/public_html/"#DefaultTicketName
            {App.printInfo 'Loading `'#TicketFile#'\'...'}
            OldTicket = {VS2A {XURL.loadVS TicketFile}}
            {App.showInfo ' done.'}
            MyTicketFile= TicketFile
         elseof BROKER_TICKET then
            TicketFile = false 
            OldTicket  = {VirtualString.toAtom BROKER_TICKET}
            MyTicketFile = OldTicket
         end
      end
      
      {App.printInfo 'Connecting to \''#OldTicket#'\'...'}
      BrokerProc = {Connection.take OldTicket}
      {App.showInfo ' done.'}
      {App.printInfo 'Sending ping($)...'}
      Signal = {BrokerProc ping($)}
      {WaitOr Signal {Alarm 50000}}
      if {IsFree Signal} then
         {App.showInfo ' timeout (50 sec.)'}
         {App.showInfo 'The broker does not respond, maybe crashed...'}
         raise timeout end
      end
      {App.printInfo ' received: '} {App.show Signal}
      {App.showInfo 'A broker is already running. Exiting...'}
      {App.exit 0}
   catch _ then
      {Delay 1000}
      {App.showInfo ' failed.'}
   end
   
   %% Set the URL where the broker-ticket can be found by other brokers.
   
   if {HasFeature Args ticketurl} then %% ToDo neu machen
      MyTicketURL = case  Args.ticketurl
                    of unit then Args.ticketfile
                    [] X then X
                    end
   else
      MyTicketURL = Args.ticketfile
   end

   PortPoint
   PortTicket
   PortServiceID 
   %%  Create a new broker if there is no one running:
   proc {DoExit _}
      if {HasFeature Args ticketfile} then
         {App.printInfo 'Removing broker-ticket...'}
         {OS.unlink Args.ticketfile}
         {App.showInfo ' done.'}
      end
      {App.printInfo 'Unsetting $BROKER_TICKET...'}
      {App putEnv('BROKER_TICKET' 'false')}
      {App.showInfo ' done.'}
      try
         if {IsDet PortPoint} andthen {IsDet PortServiceID} then 
            {PortPoint retire(PortServiceID)}
         end
      catch Err then
         {App.showError 'Error in "{PortPoint retire(...)}":'}
         {App printExc(Err)}
      end
      
   end

   Server
   {App.printInfo 'Creating new broker...'}
   Server = {App newServer(Broker init() $
                           detach: true
                           info:   'broker.server'
                           onExit: DoExit)}
   {App.showInfo ' done.'}
   {App.showInfo 'Creating new broker-ticket...'}
   Gate     = {New Connection.gate init(Server)}
   MyTicket = {Gate getTicket($)}
   {App.showInfo 'New ticket is \''#MyTicket#'\'.'}
in
   {App.printInfo 'Setting $BROKER_TICKET...'}
   {App putEnv('BROKER_TICKET' MyTicket)}
   {App.showInfo ' done.'}

   if {HasFeature Args ticketfile} then
      FileName = Args.ticketfile
   in
      {App.printInfo "Writing ticket to `"#FileName#"'..."}
      {File.saveVS MyTicket FileName}
      {App.showInfo ' done.'}
      {App.showInfo "Ticket available at `"#MyTicketURL}
      try
         if PortTicketURL \= false then
            {App.showInfo "Registering ticket at port-daemon..."}
            {App.printInfo "Loading `"#PortTicketURL#"'..."}
            PortTicket = {VS2A {XURL.loadVS PortTicketURL}}
            {App.showInfo ' done.'}      
	    
            {App.printInfo "Connecting to port-daemon..."}
            PortPoint = {Connection.take PortTicket} 
            {WaitOr PortPoint {Alarm 10000}}
            if {IsFree PortPoint} then
               {App.showInfo ' timeout (10 sec.)'}
               {App.showInfo 'The port-daemon does not respond, maybe crashed...'}
               raise timeout end
            else
               {App.showInfo ' done.'}
            end
            {App.printInfo "PortPoint = "} {App.show PortPoint}
            {PortPoint offer({VS2A MyTicketURL} MyTicket ?PortServiceID mode: atom host:Host)}
         end
      catch _ then
         {App.showInfo' failed'}
%	    {App.showInfo 'Warning: There is no port-daemon!'}
      end
      if Args.writeapplet then
         {App.printInfo 'Writing firewall applet...'}
         {FireWall.makeApplet
          {VS2A MyTicket}
          Port
          'x-ozlib://mathweb/mathweb-up.exe'
          Home#"/public_html/"#FireWallAppletName
         }
         {App.showInfo 'done.'}
      end
   end
   
   {App.exit 0}
   */
   
   %% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
   %% from old xmlrpcd.oz :
   %% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
   
   VS2A = VirtualString.toAtom
   VS2S = VirtualString.toString
   
   fun {ExceptionToVS Exc}
      {Error.messageToVirtualString {Error.exceptionToMessage Exc}} 
   end
   
   AppName = 'xmlrpcd'
   App     = {New XApplication.manager init}

   Spec = record(port(single char:&p type:int default:40000)
                 hostname(single char:&h type:string default:Internet.hostname)
                 brokerticket(single char:[&t &b] type:string
                              default:"http://www.mathweb.org/~mathweb/broker@leibniz")
                 portticketurl(single    type:string
                               default:"http://www.mathweb.org/~mathweb/port-daemon@leibniz")
                 name(    single char:&n type:atom   default:'xmlrpc')
                 pidfile( single         type:string default:false)
                 default( single         type:string default:false)
                 debug(   single char:&d type:bool   default:false)
                 loglevel(single char:&l type:int(min:0 max:9) default:1)
                )
   Args
   try
      Args = {App.getCmdArgs Spec}
   catch error(ap(usage S)...) then
      {App.showError AppName#": "#S}
      {App.exit 1}
   end
   
   if Args.hostname\=Internet.hostname andthen
      {Internet.sameHosts Args.hostname Internet.hostname}==false
   then
      {App.showError "Sorry, "#Args.hostname#" and "#Internet.hostname#
       " seem to be different hosts :("}
      {App.exit 1}
   end
   HOSTNAME = Args.hostname 
   PORT     = Args.port
   PREFIX   = "http://"#HOSTNAME#":"#PORT
   
   proc {DebugBrowse X}
      if Args.debug then
         {Browser.browse X}
      end
   end
   
   %% ====================================
   %% Create the XMLRPC server
   %% ====================================
   Server
   try
      Server = {New RpcServer init(port:        PORT
                                   acceptClass: RpcConnection
                                   %%           AppletServer.connectionClass
                                   logLevel:    Args.loglevel)}
   catch system(os(...)...) then
      {App.showInfo 'Port '#PORT#' is occupied.'}
      {App.exit 1}
   [] Err then
      {App printExc(Err)}
      {App.exit 1}
   end
   
   %% =====================
   %% Connect to the broker
   %% =====================
   local BrokerTicket BrokerURL
   in
      case {App.getEnv 'BROKER_TICKET'}
      of false then
         if {HasFeature Args brokerticket} then
            BrokerURL = Args.brokerticket
            {App.printInfo "Loading broker-ticket from `"#BrokerURL#"'..."}
            BrokerTicket = if {File.type BrokerURL}==dir
                           then {Pickle.load BrokerURL#"/broker-ticket.ozc"}
                           else {VS2A {XURL.loadVS BrokerURL}}
                           end
            {App.showInfo " done."}
         else
            {App.show no_broker_ticket_set}
            BrokerURL = "http://www.ags.uni-sb.de/~omegadev/broker-ticket.ozc"
            {App.printInfo "Loading broker-ticket from `"#BrokerURL#"'..."}
            BrokerTicket = {Pickle.load BrokerURL}
            {App.showInfo " done."}
         end
      [] BROKER_TICKET then
         {App.show broker_ticket(BROKER_TICKET)}
         BrokerURL    = false
         BrokerTicket = {VirtualString.toAtom BROKER_TICKET}
      end
      {App.printInfo "Connecting to broker at "#BrokerTicket#"..."}
      Broker = {Connection.take BrokerTicket}
      {App.showInfo " done."}
   end
   
   %% ====================================
   %% Server class
   %% ====================================
   class XmlRpcService from BaseObject

      meth ping($) unit end
      meth enter(...) skip end
      meth leave(...) skip end
      
      meth addHandler(...)=Msg     {Server Msg}  end
      meth removeHandler(...)=Msg  {Server Msg}  end
   end
   ServiceObj = {New XmlRpcService noop}
   ServiceID  = {Broker offer('XMLRPC_SERVER' ServiceObj $ mode:pass_on)}

   %% add dummy handler
   {Server addHandler("/" DummyHandler.call mode:fun2)}
   
   %% ====================================
   %% enable a nice exit
   %% ====================================
   {App.showInfo HOSTNAME#":"#PORT}
   {App.showInfo "PID "#{OS.getPID}}
   
   if Args.pidfile \= false then 
      {File.saveVS {OS.getPID}#"\n" Args.pidfile}
   end
   
   ExitSignal
   local
      proc {Term SIGNAL}
         {App.showError "*** "#SIGNAL#" ***"}
         ExitSignal=unit
      end
   in
      {OS.signal 'SIGHUP' Term}
      {OS.signal 'SIGINT' Term}
      {OS.signal 'SIGTERM' Term}
   end

   try
      {Wait ExitSignal}
   catch E then
      {App.showInfo {ExceptionToVS E}}
   finally
      {App.showInfo 'exiting..'}
      %% find a generic way to do cleanup in a handler
      %%{ObjectRegistry releaseAll}
      {Server close}
      {App.exit 0}
   end
end

