%%%
%%% PROTEIN agent
%%%

functor
   
import
   OS(getEnv)

   XService(manager: ServiceManager)
   at 'x-ozlib://mathweb/sys/XService.ozf'
   ShellProverClass('class': ShellProver)
   at 'x-ozlib://mathweb/sys/ShellProver.ozf'

   XApplication
   at 'x-ozlib://mathweb/share/XApplication.ozf'
   
define
   AppName     = 'protein'
   ServiceName = 'PROTEIN'
   App         = {New XApplication.manager init}

   VS2BS = VirtualString.toByteString

   Flags = "--------------------        flags       --------------------"

   PROTEIN = {OS.getEnv "PROTEINHOME"}
   
   class ProteinService from ShellProver
      feat
         name: protein

         
      meth submitProblem(ProblemBS...)
%	 {self saveVS(ProblemBS 'protein.tme')}
	 {self saveVS(%"protein_flag(trace,info).\n"#
                      "protein_flag(trace,internal).\n"#                       
                      ProblemBS
                      'protein.tme')}
	 CallProtein = PROTEIN#' protein'
      in
	 {self start(CallProtein)}
      end

      meth analyzeResult($)
         F Trc Tree State Output
         fun {Take}
            case {F getS($)}
            of false    then nil
            [] !Flags   then Flags#"\n"
            elseof Line then Line#"\n"#{Take} 
            end
         end
      in
         {App.showInfo 'analyze'}
	 try
%	    {self save}
	    F = {self openRead('protein.trc' $)}
	    {App.showInfo 'before taking'}
	    Trc = {Take}
	    {F close}
	    {App.showInfo 'after taking'}
	 catch system(...) then
            if {IsFree Trc} then
               Trc = nil
            end
         end
	 try
	    {App.showInfo 'before reading tree'}
            Tree = {self loadVS('protein.tree' $)}
	    {App.showInfo 'after reading tree'}
         catch system(...) then
            if {IsFree Tree} then
               Tree = nil
            end
         end
         State = case Tree
                 of nil then
                    case Trc
                    of nil then error
                    else undetermined end
                 else proof
                 end
%	 Failed = (Tree == nil)
         Output = if State == proof then 
                     {VS2BS Tree#"\n"#"%%%%% THIS WAS THE .TREE FILE, NEXT IS THE .TRC FILE %%%%%"#"\n"#Trc}
                  else 
                     nil
                  end
	 atp_result(state: State
                    name: self.name
                    host: self.host
                    output: Output)
      end         
   end
   
   ServMan = {New ServiceManager init(ServiceName ProteinService
                                      appName: AppName
                                      appMan:  App)}
   {ServMan offerService}
   {App.exit 0}
end






%       meth submitProblem(ProblemBS...)
% %	 {self saveVS(ProblemBS 'protein.tme')}
% 	 {self saveVS(("protein_flag(trace,rme).\n"#ProblemBS)
% 		      'protein.tme')}
% 	 CallProtein = PROTEIN#' protein'
%       in
% 	 {self start(CallProtein)}
%       end

%       meth analyzeResult($)
%          Trc Tree ProofBS
% 	 try
% 	    {self save}
% 	    F = {self openRead('protein.trc' $)}

% 	    fun {Take}
% 	       case {F getS($)}
% 	       of false then ""
% 	       [] !Flags   then Flags#"\n"
% 	       elseof Line then Line#"\n"#{Take} 
% 	       end
% 	    end
% 	 in
% 	    {App.showInfo 'before taking'}
% 	    Trc = {Take}
% 	    {F close}
% 	    {App.showInfo 'after taking'}
% 	 catch system(...) then
%             Trc = nil end
% 	 try
% 	    {App.showInfo 'before reading tree'}
%             Tree = {self loadVS('protein.tree' $)}
% 	    {App.showInfo 'after reading tree'}
%          catch system(...) then
%             Tree = nil
%          end
% 	 Failed = (Tree == nil)
%       in
% 	 ProofBS = if Failed
% 		   then {VS2BS "unknown result\n"}
% 		   else 
% 		      {VS2BS Tree#"\n"#"%%%%% THIS WAS THE .TREE FILE, NEXT IS THE .TRC FILE %%%%%"#"\n"#Trc}
% 		   end
% 	 s(string: ProofBS
% 	   bool  : Failed
% 	   host:   self.host)
%       end         
